<?php
/*
 +----------------------------------------------------------------------+
 | Copyright (C) 2006 Andreas Braun                                   	|
 |									|
 | This program is free software. You can redistribute it		|
 | and/or modify it under the terms of the GNU General Public License	|
 | as published by the Free Software Foundation; either version 2       |
 | of the License, or (at your option) any later version.               |
 |                                                                      |
 | This program is distributed in the hope that it will be useful, but  |
 | WITHOUT ANY WARRANTY; without even the implied warranty of     	|
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
 | GNU General Public License for more details.     			|
 |                    							|
 +----------------------------------------------------------------------+
*/

chdir('../../');

$guest_account = true;

include ('./include/auth.php');
include_once('./plugins/reportit/lib_int/funct_online.php');
include_once('./plugins/reportit/lib_int/const_reports.php');
include_once('./plugins/reportit/lib_int/funct_shared.php');


$report_actions = array(
    1 => 'Run Report',
    2 => 'Delete',
    3 => 'Duplicate'
    );

if (!isset($_REQUEST['action'])) {
    $_REQUEST['action'] = '';
}

switch ($_REQUEST['action']) {
    case 'actions':
	form_actions();
	break;
    case 'report_edit':
	include_once($config["include_path"] . "/top_header.php");	
	report_edit();
	include_once($config["include_path"] . "/bottom_footer.php");
	break;
    case 'save':
	form_save();
	break;
    default:
	include_once($config["include_path"] . "/top_header.php");
	standard();
	include_once($config["include_path"] . "/bottom_footer.php");
	break;
}



function standard() {
    global $colors, $report_actions, $minutes;
    
    //Select every report with regard to the ownership
    $myId	  = my_id();
    $myName 	  = my_name();
    $reportAdmin  = re_admin();
    
    $sql = 'SELECT
		a.*,
		b.user_id, b.description AS template_description
	    FROM 
		reportit_reports AS a
	    LEFT JOIN
		reportit_templates AS b
	    ON 
		b.id 	= a.template_id';
    
    if ($reportAdmin) {
	$sql = $sql . ' ORDER BY b.user_id, a.description';
	$report_list = db_fetch_assoc($sql);
    }else {
	$sql = $sql . " WHERE b.user_id = $myId ORDER BY a.description";
	$report_list = db_fetch_assoc($sql);
    }
    
    //Number of reports
    $number_of_reports = count($report_list);
    
    //Start HTML Output
    html_start_box("<strong>Report configurations</strong> [$number_of_reports]", "98%", $colors["header"], "2", "center", "cc_reports.php?action=report_edit");
    
    if ($reportAdmin) {
	html_header_checkbox(array("Description", "Owner", "Template", "Period (from - to)", "Runtime (GMT)&nbsp;/&nbsp;(s)", "Public", "Scheduled", "Data Items"));
    }else {
	html_header_checkbox(array("Description", "Template", "Period (from - to)", "Runtime (GMT)&nbsp;/&nbsp;(s)", "Public", "Data Items"));
    }
    
    $i = 0;
    
    if (sizeof($report_list) > 0) {
	foreach($report_list as $report) {
	    form_alternate_row_color($colors["alternate"], $colors["light"], $i); $i++;
		?>
		<td>
			<a class='linkEditMain' href="cc_reports.php?action=report_edit&id=<?php print $report["id"];?>">
			    <?php print $report["description"];?>
			</a>
		</td>
		<?php 
		if($reportAdmin) {
		    ?><td><?php
		    $ownerId = $report['user_id'];
		    if ($reportAdmin AND $ownerId != $myId) {
			print other_name($ownerId);
		    }else {
		     print $myName;
		    }
		    ?></td><?php
		}
		?>
		<td>
			<?php print $report['template_description'];?>
		</td>
		<td>
			<?php 
			    if ($report['dynamic']== true && $report['last_run'] == 0) {
				$dates = get_timespan($report['preset_timespan'], $report['present']);
				print "{$dates['start_date']} - {$dates['end_date']}";
			    }else {
				print "{$report['start_date']} - {$report['end_date']}";
			    }
			?>
		</td>
		<td>
			<?php print "{$report['last_run']}&nbsp;&nbsp;/&nbsp;{$report['runtime']}";?>
		</td>
		<td>
			<?php 
			    if($report['public'] == 'on') {
				print '<b>&radic;</b>';
			    }else {
				print '';
			    }
			?>
		</td>
		<?php 
		if($reportAdmin) {
		    print "<td>"; 
		    if($report['scheduled'] == '1') {
			print '<b>&radic;</b>';
		    }else {
			print '';
		    }
		    print "</td>";		    
		}
		?>	
		<td>
			<a class='linkEditMain' href="cc_rrdlist.php?&id=<?php print $report["id"];?>">
			    <?php print 'Edit Data Items';?>
			</a>
		</td>
		<td style="<?php print get_checkbox_style();?>" width="1%" align="right">
			<input type='checkbox' style='margin: Opx;' name='chk_<?php print $report["id"];?>' title="Select">
			
		</td>
	    </tr>
	    <?php
	}
    }else {
	print "<tr><td><em>No reports</em></td></tr>\n";
    }

    html_end_box(true);
    
    draw_actions_dropdown($report_actions);            
    
}


function form_save() {
    
    global $colors, $templates, $timespans, $frequency;

    //Provoke an error if there's no template available
    if(isset($templates[0])) {
	$_POST['report_template'] = false;
	$dummy = form_input_validate($_POST['report_template'], 'report_template', NULL, false, 2);
    }
    
    $report_data['id']	  	  	= $_POST['id'];
    $report_data['description']   	= form_input_validate($_POST['report_description'], 'report_description',NULL ,false,3);
    
    if(isset($_POST['report_template']) && $_POST['id'] == 0) {
	$report_data['template_id']	= $_POST['report_template'];
    }
    
    if(isset($_POST['report_timespan'])) {
	$report_data['preset_timespan'] = $timespans[$_POST['report_timespan']];	
    }
    
    $report_data['public']	  	= (isset($_POST['report_public'])) ? $_POST['report_public'] :'off';
    $report_data['start_date']		= (isset($_POST['report_start_date'])) ? $_POST['report_start_date'] :'';
    $report_data['end_date']		= (isset($_POST['report_end_date'])) ? $_POST['report_end_date'] :'';
    $report_data['last_run']		= '';
    
    if (isset($_POST['report_dynamic'])) {
	$report_data['dynamic'] = 1;
    }else {
	$report_data['dynamic'] = 0;
	$report_data['preset_timespan'] = '';
    }
    
    if (isset($_POST['report_present'])) {$report_data['present'] = true;}else {$report_data['present'] = false;}    
        
    //check missing scheduling informations
    if(!isset($_POST['report_schedule'])) {
	//Check user permissions
	if(re_admin()) {
	    $report_data['scheduled'] = 0;
	    $report_data['frequency'] = '';
	}
    }else {
	$report_data['scheduled'] = 1;
	$report_data['frequency'] = $frequency[$_POST['report_schedule_frequency']];
    }
    
    //Check start- and end date if we need them
    if (!isset($_POST['report_dynamic'])) {

	if(!preg_match('/^\d{4}\-\d{2}\-\d{2}$/', $_POST['report_start_date'])) {
	    raise_message(3);
	    $_SESSION["sess_error_fields"]['report_start_date'] = 'report_start_date';
	}

	if(!preg_match('/^\d{4}\-\d{2}\-\d{2}$/', $_POST['report_end_date'])) {	
	    raise_message(3);
	    $_SESSION["sess_error_fields"]['report_end_date'] = 'report_end_date';
	}	
	
	if(!is_error_message()) {
		list($ys, $ms, $ds) = explode("-", $_POST['report_start_date']);
		list($ye, $me, $de) = explode("-", $_POST['report_end_date']);
	
	    if(!checkdate($ms, $ds, $ys)) {
		raise_message(3);
		$_SESSION["sess_error_fields"]['report_start_date'] = 'report_start_date';
	    }
	
	    if(!checkdate($me, $de, $ye)) {
	    	raise_message(3);
		$_SESSION["sess_error_fields"]['report_end_date'] = 'report_end_date';
	    }
	}
	
	if(!is_error_message()) {
	    if (($start_date = gmmktime(0,0,0,$ms,$ds,$ys)) > ($end_date = gmmktime(0,0,0,$me,$de,$ye)) || $ys > $ye || $ys > gmdate("Y")) {
		raise_message(3);
		$_SESSION["sess_error_fields"]['report_start_date'] = 'report_start_date';
	    }
	    if (($end_date = gmmktime(0,0,0,$ms,$ds,$ys)) > gmmktime() || $ye > gmdate("Y")) {
		raise_message(3);
		$_SESSION["sess_error_fields"]['report_end_date'] = 'report_end_date';
	    }
	}
    }
    
    if(is_error_message()) {
	header('Location: cc_reports.php?action=report_edit&id=' . $_POST['id']);
    }else {
	//Save data
	sql_save($report_data, 'reportit_reports');
	
	//Create rrdlist_table
	if($_POST['id'] == 0) {
    	    $report_id = db_fetch_insert_id();
	    create_rrd_table($report_id);
	}
	//Return to list view if it was an existing report
	if($_POST['id']!='0') {
	    header('Location: cc_reports.php');
	    raise_message(1);
	}else {
	    header('Location: cc_reports.php?action=report_edit&id=' . $report_id);
	}
    }
}


function report_edit() {

    global $colors, $templates, $timespans, $graph_timespans, $frequency;

    /* ================= input validation ================= */
    input_validate_input_number(get_request_var('id'));
    /* ==================================================== */

    if (!empty($_GET['id'])) {	
	$report_data		= db_fetch_row('SELECT * FROM reportit_reports WHERE id=' . $_GET['id']);
	$header_label 		= '[edit: ' . $report_data['description'] . ']';
	
	//Update report_data array for presets
	$report_data['preset_timespan'] = array_search($report_data['preset_timespan'], $timespans);
	//Update report_data array for schedule frequency
	$report_data['frequency'] = array_search($report_data['frequency'], $frequency);
	
	?>
	    <table width="98%" align="center">
		<tr>
		    <td class="textinfo" valign="top" align="right">
			<span style="color: #c16921;">*</span><a href="cc_rrdlist.php?action=rrdlist_add&id=<?php print $_GET['id'];?>">Create Data Items</a>
		    </td>
		</tr>
	    </table><br>
	<?php
		
    }else {
	$header_label 		= '[new]';
    }

    html_start_box("<strong>Report configuration</strong> $header_label", "98%", $colors["header"], "2", "center", "");
	
    $form_array = array(
	    		'id'			=> array(
			    'method'		=> 'hidden_zero',
			    'value'		=> (isset($_GET['id']) ? $_GET['id'] : '0')
			    ),
			'user_id'		=> array(
			    'method'		=> 'hidden_zero',
			    'value' 		=> (isset($report_data['user_id']) ? $report_data['user_id'] : my_id())
			    ),
			'report_header'		=> array(
			    'friendly_name'	=> 'General',
			    'method'		=> 'spacer',
			    ),
			'report_description'	=> array(
			    'friendly_name' 	=> 'Name',
		            'method' 		=> 'textbox',
			    'max_length'	=> '100',
			    'description'	=> 'The name given to this report',
			    'value' 		=> (isset($report_data['description']) ? $report_data['description'] : '')
			    ),
			'report_template'	=> array(
			    'friendly_name'	=> 'Template',
			    'method'		=> 'drop_array',
			    'default'		=> 'Null',
			    'description'	=> 'The template your report should depends on',
			    'value'		=> (isset($report_data['template_id']) ? $report_data['template_id'] : ''),
			    'array'		=> $templates
			    ),
			'report_public'		=> array(
			    'friendly_name'	=> 'Public',
			    'method'		=> 'checkbox',
		    	    'default'		=> 'off',
		    	    'description'	=> "By using this function everyone can see this report under tab 'reports'",
		    	    'value'		=> (isset($report_data['public']) ? $report_data['public'] : 'off'),
		    	    )
			);

			    
   $form_array_2 = array(
   			'report_header_2'	=> array(
			    'friendly_name'	=> 'Sliding Time Frame',
			    'method'		=> 'spacer',
			    ),			    
			'report_dynamic'	=> array(
			    'friendly_name'	=> 'Enable Sliding Time Frame',
			    'method'		=> 'custom',
			    'default'		=> 'false',
		    	    'description'	=> 'Enable/disable using a sliding timeframe instead of an static one.',
		    	    'value'		=> "<input type='checkbox' id='report_dynamic' name='report_dynamic' onClick='dynamic()'". ((!isset($report_data['dynamic']) || $report_data['dynamic'] == true) ? ' checked' :'') . "> ",
		    	    ),
			'report_timespan'	=> array(
			    'friendly_name'	=> 'Sliding Time Frame',
			    'method'		=> 'drop_array',
		    	    'description'	=> 'The time frame you want to analyse in relation to current time.<br>This means calendar days, calendar months and calendar years.',
		    	    'value'		=> (isset($report_data['preset_timespan']) ? $report_data['preset_timespan'] :''),
		    	    'array'		=> $timespans
		    	    ),
			'report_present'	=> array(
			    'friendly_name'	=> 'Down To The Present Day',
			    'method'		=> 'custom',
			    'default'		=> 'false',
		    	    'description'	=> 'Define sliding time frame up to date',
		    	    'value'		=> "<input type='checkbox' id='report_present' name='report_present'". ((!isset($report_data['present']) || $report_data['present'] == true) ? ' checked' :'') . "> ",
		    	    ),
			'report_start_date'	=> array(
			    'friendly_name' 	=> 'Static Time Frame - Start Date (From)',
		            'method' 		=> 'textbox',
			    'max_length'	=> '10',
			    'description'	=> 'To define the start date use the following format: <b>yyyy-mm-dd</b>',
			    'default'		=> 'yyyy-mm-dd',
			    'value' 		=> (isset($report_data['start_date']) ? $report_data['start_date'] : 'yyyy-mm-dd'),
			    ),
			'report_end_date'	=> array(
			    'friendly_name' 	=> 'Static Time Frame - End Date (To)',
		            'method' 		=> 'textbox',
			    'max_length'	=> '10',
			    'description'	=> 'To define the start date use the following format: <b>yyyy-mm-dd</b>',
			    'default'		=> 'yyyy-mm-dd',
			    'value' 		=> (isset($report_data['end_date']) ? $report_data['end_date'] : 'yyyy-mm-dd'),
			    )    
	    		);

    $form_array_3 = array(
   			'report_header_4'	=> array(
			    'friendly_name'	=> 'Scheduling',
			    'method'		=> 'spacer',
			    ),			    
			'report_schedule'	=> array(
			    'friendly_name'	=> 'Enable scheduled reporting',
			    'method'		=> 'custom',
		    	    'default'		=> 'false',
		    	    'description'	=> 'Enable/disable scheduled reporting. Sliding time frame should be enabled',
		    	    'value'		=> "<input type='checkbox' id='report_schedule' name='report_schedule' onClick='schedule()'". ((isset($report_data['scheduled']) && $report_data['scheduled'] == true) ? ' checked' :'') . ">",
		    	    ),
			    
		'report_schedule_frequency'	=> array(
			    'friendly_name'	=> 'Frequency',
			    'method'		=> 'drop_array',
		    	    'description'	=> 'Select the frequency for processing this report. Be sure that the correct crontab/task is running.',
		    	    'value'		=> (isset($report_data['frequency']) ? $report_data['frequency'] :''),
		    	    'array'		=> $frequency
		    	    )
			);

    draw_edit_form(array(
			'config' => array(),
			'fields' => $form_array
			));
    html_end_box();
    
    html_start_box("", "98%", $colors["header"], "2", "center", "");
    draw_edit_form(array(
			'config' => array(),
			'fields' => $form_array_2
			));
    html_end_box();

    if (re_admin()) {
	html_start_box("", "98%", $colors["header"], "2", "center", "");
        draw_edit_form(array(
			'config' => array(),
			'fields' => $form_array_3
			));
	html_end_box();    
    }

    form_save_button('cc_reports.php');  
 
    //Now we need some javascript to make it dynamic
    ?>
	<script type="text/javascript">
	    <?php
	        if (!empty($_GET['id'])) {    
		    ?>
		    document.getElementById('report_template').disabled="disabled";
		    <?php
		}
	    ?>
		
    	    dynamic();
		
    	    function dynamic() {
		if (document.getElementById('report_dynamic').checked){
		    document.getElementById('report_start_date').disabled=true;
		    document.getElementById('report_start_date').value='yyyy-mm-dd';	    
		    document.getElementById('report_end_date').disabled=true;		
		    document.getElementById('report_end_date').value='yyyy-mm-dd';
		    document.getElementById('report_timespan').disabled=false;					
		    document.getElementById('report_present').disabled=false;
		}else {
		    document.getElementById('report_start_date').disabled=false;
		    document.getElementById('report_end_date').disabled=false;		
		    document.getElementById('report_timespan').disabled=true;		
		    document.getElementById('report_present').disabled=true;
		}
	    }
	
	    function schedule() {
		if(document.getElementById('report_schedule').checked){
		    document.getElementById('report_dynamic').checked = true;
		    dynamic();
		}
	    }	    	
	</script>
    <?php
}


function form_actions() {

    global $colors, $report_actions;

    if (isset($_POST['selected_items'])) {
	$selected_items = unserialize(stripslashes($_POST['selected_items']));

	if ($_POST['drp_action'] == '2') { // DELETE REPORT
	    $report_datas = db_fetch_assoc('SELECT id FROM reportit_reports WHERE ' . array_to_sql_or($selected_items, 'id'));
	    
	    if (sizeof($report_datas) > 0) {
		foreach ($report_datas as $report_data) {
		    db_execute('DELETE FROM reportit_reports WHERE id=' . $report_data['id']);
		    db_execute('DROP TABLE IF EXISTS reportit_rrdlist_' . $report_data['id']);
		    db_execute('DROP TABLE IF EXISTS reportit_results_' . $report_data['id']);
		}
	    }
	}elseif ($_POST['drp_action'] == '3') { //DUPLICATE REPORT TEMPLATE
	
	    for ($i=0;($i<count($selected_items));$i++) {
		/* ================= input validation ================= */
		input_validate_input_number($selected_items[$i]);
		/* ==================================================== */
		
		$report_data = db_fetch_row('SELECT * FROM reportit_reports WHERE id = ' . $selected_items[$i]);  
		$report_data['id'] = 0;
		$report_data['description'] = str_replace("<report_title>", $report_data['description'], $_POST['report_addition']);
		sql_save($report_data, 'reportit_reports');

		//Get new dataset's (auto_incrementing) id 
		$sql = "SELECT id FROM reportit_reports WHERE description ='{$report_data['description']}'";
		$new_id = db_fetch_cell($sql);
		
		//In Hope of compatibility to all people which have not MySQL 4.1 or higher:
		//Create table for saving the rrdlist
		create_rrd_table($new_id);

		//Copy original rrdlist table  to new rrdlist table
		$sql = "INSERT INTO reportit_rrdlist_" . $new_id . " SELECT * FROM reportit_rrdlist_" . $selected_items[$i];
		db_execute($sql);
	    }
	}
	header('Location: cc_reports.php');
	exit;
    }

    //Set preconditions
	$ds_list = ''; $i = 0;

    foreach($_POST as $key => $value) {
	
	if(strstr($key, 'chk_')) {
	    //Fetch report id
	    $id = substr($key, 4);
	    $report_ids[] = $id;
	    // ================= input validation =================
			input_validate_input_number($id);
	    // ==================================================== 
	    
	    //Fetch report description
	    $report_description 	= db_fetch_cell('SELECT description FROM reportit_reports WHERE id=' . $id);
	    $ds_list[$report_description] = '';
	}
    }

    //For running report jump to cc_run.php!
    if ($_POST['drp_action'] == '1') { // RUNNING REPORT
	//Only one report is allowed to run at the same time, so select the first one:
	if(isset($report_ids)) {
    	    $report_id = $report_ids[0];

	    //Update $_SESSION
	    $_SESSION['run'] = '1';

	    //Jump to cc_run.php
	    header('Location: cc_run.php?action=calculation&id=' . $report_id);
	    exit;
	}
    }

    include_once('./include/top_header.php');
    html_start_box("<strong>" . $report_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "2", "center", "");
    print "<form action='cc_reports.php' method='post'>\n";

    if ($_POST['drp_action'] == '2') { //DELETE REPORT
	print "	<tr>
		    <td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
			<p>Are you sure you want to delete the following report configuration(s)?<br>
			</p>";
			if(is_array($ds_list)) {
			    print "Report configuration(s):";
			    foreach($ds_list as $key => $value) {
				print "<li><b>$key</b><br>";
			    }
			    print "</li>";
			}
	print "     </td>
		</tr>\n";
	
    }elseif ($_POST['drp_action'] == '3') { // DUPLICATE REPORT
	print "	<tr>
		    <td class='textArea' bgcolor='#" . $colors['form_alternate1']. "'>
			<p>When you click \"yes\", the following report configuration will be duplicated. You can
			   optionally change the title format for the new report.
			</p>";
			if(is_array($ds_list)) {
			    print "Report configuration:";
			    foreach($ds_list as $key => $value) {
				print "<li><strong>$key</strong></li><br>";
			    }
			}		
			print "<p><strong>Title Format:</strong><br>"; 
			form_text_box("report_addition", "<report_title> (1)", "", "255", "30", "text");
	print "		</p>
		    </td>
		</tr>\n";
    }
    
    
    if (!is_array($ds_list)) {
	print "<tr><td bgcolor='#" . $colors['form_alternate1']. "'><span class='textError'>You must select at least one report.</span></td></tr>\n";
	$save_html = '';
    }else {
	$save_html = "<input type='image' src='../../images/button_yes.gif' alt='Save' align='absmiddle'>";
    }

    print " <tr>
		<td align='right' bgcolor='#eaeaea'>
		    <input type='hidden' name='action' value='actions'>
		    <input type='hidden' name='selected_items' value='" . (isset($report_ids) ? serialize($report_ids) : '') . "'>
		    <input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
		    <a href='cc_reports.php'><img src='../../images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
		    $save_html
		</td>
	    </tr>";
    
    html_end_box();
    include_once('./include/bottom_footer.php');}
?>