<?php
/*
 +----------------------------------------------------------------------+
 | Copyright (C) 2006 Andreas Braun                                   	|
 |									|
 | This program is free software. You can redistribute it		|
 | and/or modify it under the terms of the GNU General Public License	|
 | as published by the Free Software Foundation; either version 2       |
 | of the License, or (at your option) any later version.               |
 |                                                                      |
 | This program is distributed in the hope that it will be useful, but  |
 | WITHOUT ANY WARRANTY; without even the implied warranty of     	|
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
 | GNU General Public License for more details.     			|
 |                    							|
 +----------------------------------------------------------------------+
*/

chdir('../../');

$guest_account = true;

include ('./include/auth.php');
include_once('./plugins/reportit/lib_int/funct_shared.php');
include_once('./plugins/reportit/lib_int/const_runtime.php');
include_once('./plugins/reportit/lib_int/const_rrdlist.php');


$rrdlist_actions = array(
    1 => "Delete",
    2 => "Copy settings to all"
    );

$rrdadd_actions = array(
    1 => "Add"
    );

if (!isset($_REQUEST["action"])) {
    $_REQUEST["action"] = "";
}

switch ($_REQUEST["action"]) {
    case 'actions':
	form_actions();
	break;
    case 'save':
	form_save();
	break;
    case 'rrdlist_add':
    	include_once($config["include_path"] . "/top_header.php");
	rrdlist_add();
	include_once($config["include_path"] . "/bottom_footer.php");
	break;
    case 'rrdlist_edit':
    	include_once($config["include_path"] . "/top_header.php");
	rrdlist_edit();
	include_once($config["include_path"] . "/bottom_footer.php");
	break;
    default:
	include_once($config["include_path"] . "/top_header.php");
	standard();
	include_once($config["include_path"] . "/bottom_footer.php");
	break;
}


function form_save() {
    
    global $colors, $timezone, $shifttime, $shifttime2, $weekday;

    /* ================= input validation ================= */
    input_validate_input_number(get_request_var('id'));
    input_validate_input_number(get_request_var('report_id'));
    input_validate_input_number(get_request_var('rrdlist_timezone'));
    input_validate_input_number(get_request_var('rrdlist_shifttime_start'));
    input_validate_input_number(get_request_var('rrdlist_shifttime_end'));    
    input_validate_input_number(get_request_var('rrdlist_weekday_start'));
    input_validate_input_number(get_request_var('rrdlist_weekday_end'));
    /* ==================================================== */    
    
    //Check start and end of shifttime input.
    //If start == end then reduce end at 5 minutes by reminding to rrdtool's stepping!
    
    $a =  $_POST['rrdlist_shifttime_start'];
    $b = &$_POST['rrdlist_shifttime_end'];
    
    if($a == $b) {
	$b--;
	if($b <0) {
	    $b = count($shifttime)-1;
	}
    }
    
    //Prepare data array    
    $rrdlist_data['id']		  	= $_POST['id'];
    $rrdlist_data['start_day']   	= $weekday[$_POST['rrdlist_weekday_start']];
    $rrdlist_data['end_day']   		= $weekday[$_POST['rrdlist_weekday_end']];
    $rrdlist_data['start_time']		= $shifttime[$_POST['rrdlist_shifttime_start']];
    $rrdlist_data['end_time']		= $shifttime2[$_POST['rrdlist_shifttime_end']];
    $rrdlist_data['timezone']		= $timezone[$_POST['rrdlist_timezone']];
    
    //Save data
    sql_save($rrdlist_data, "reportit_rrdlist_" . $_POST['report_id']);
    
    //Reset report
    reset_report($_POST['report_id']);
    
    //Return to list view
    raise_message(1);
    header("Location: cc_rrdlist.php?&id={$_POST['report_id']}");
}


function rrdlist_add() {
    global $colors;
    
    //Get out of here when 'add' has been clicked and checkboxes has been transmitted by $_POST
    if(isset($_POST['save_x']) && isset($_POST['save_y'])) {
	
	//Search all checkboxes and put them into array $rrd_ids
	foreach($_POST as $key => $value) {
	    if(strstr($key, 'chk_')) {
	    //Fetch rrd id;
	    $id = substr($key, 4);
	    $rrd_ids[] = $id;
	    }
	}
	//When we have found some checkboxes check and save them!
	if(isset($rrd_ids)) {
	    $rrd = '';
	    foreach($rrd_ids as $rd) {
		$rrd = $rrd . "($rd),";
	    }

	//Remove last comma
	$rrd = substr($rrd, 0, strlen($rrd)-1);
		
	//Save now!
	$sql = "INSERT INTO reportit_rrdlist_{$_GET['id']} (id) VALUES $rrd";
	db_execute($sql);

	//Reset report
	reset_report($_GET['id']);
	}	    
    }
    
    $report_data		= db_fetch_cell('SELECT description FROM reportit_reports WHERE id=' . $_GET['id']);    
    $header_label 		= '[add to report: ' . $report_data .']';
    
    //Fetch host names for dropdown
    $sql = "SELECT 
		description
	    FROM 
		host
	    ORDER BY 
		description ASC";
    $host_array = db_fetch_assoc($sql);
    
    //Add "Any" to host_array
    $any = array('description' => 'Any');
    array_unshift($host_array, $any);

    $var = "cc_rrdlist.php?action=rrdlist_add&id={$_GET['id']}";
    
    ?>
    <table align="center" width="98%" cellpadding="3" cellspacing="1" border="0" bgcolor="<?php print $colors["header"];?>">
	<tr>
	    <td class="textHeaderDark"><b>Data Items </b><?php print "$header_label";?></td>
	    <td class="textHeaderDark" align="right">
		<b><a class="linkOverDark" href="cc_rrdlist.php?&id=<?php print $_GET['id'];?>">&raquo;&nbsp;List Data Items</a></b></td>    
	</tr>
    </table>
    <table align="center" width="98%" cellpadding="3" cellspacing="1" border="0" bgcolor="<?php print $colors["header_panel"];?>" >
    <?php
    
    html_header_checkbox(array(""),$var);
    
    html_graph_start_box();

    ?>
    <tr>
	<td>
	    <tr>
		<td>
		    <b>Filter by host:&nbsp;&nbsp;&nbsp;&nbsp;</b>
		    <select name="host_filter" size="1s">
	    	    <?php
			foreach($host_array as $key) {
			    if($_POST['host_filter'] != $key['description']) {
				print "<option value={$key['description']}>{$key['description']}</option>";
				}else {
			        print "<option selected value={$key['description']}>{$key['description']}</option>";
			    }
			}
		    ?>
		    </select>
		    <input type="text" name="text_filter" 
			<?php 
			    if(isset($_POST['text_filter'])) {
				print "value={$_POST['text_filter']}";
			    }
			?>
		    >
		    <input type="image" src='../../images/button_go.gif' alt="Go" align="absmiddle">
		</td>
	    </tr>
	</td>
    </tr>
    <?php
    html_graph_end_box();
    print "<br>";
    
    //Get the filter setting by template
    $sql = "SELECT
		c.syntax 
	    FROM
		reportit_reports AS a
	    JOIN
	    	reportit_templates AS b
	    ON
	    	a.template_id = b.id
	    JOIN
	    	reportit_types AS c
	    ON
	    	b.type_id = c.id
	    WHERE
	     	a.id={$_GET['id']}";
    $template_filter = db_fetch_cell($sql);
    
    //Get all RRDs which are not in RRD table and match with filter settings
    $sql = "SELECT
		a.local_data_id AS id,
		a.name_cache
	    FROM 
	    	data_template_data AS a
	    LEFT JOIN
		reportit_rrdlist_{$_GET['id']} AS b
	    ON
	    	a.local_data_id = b.id
	    WHERE
		b.id IS NULL
	    AND
		a.local_data_id != '0'
	    AND
		a.name_cache LIKE '$template_filter'";
		
    if (isset($_POST['host_filter']) && $_POST['host_filter'] != 'Any') {
	$sql = $sql . " AND a.name_cache LIKE '%" . $_POST['host_filter'] . "%'";
    }
    if (isset($_POST['text_filter']) && $_POST['text_filter'] != '') {
	$sql = $sql . " AND a.name_cache LIKE '%" . $_POST['text_filter'] . "%'";
    }    
    $rrdlist = db_fetch_assoc($sql);
    
    $number_of_matches = '[' . count($rrdlist) . ']';
    html_start_box("<strong>Data Items</strong> $number_of_matches", "98%", $colors["header_panel"], "2", "center", "");

    //Set preconditions
    $i = 0;
    
    if (sizeof($rrdlist) > 0) {
	foreach($rrdlist as $rrd) {
	    form_alternate_row_color($colors["alternate"], $colors["light"], $i); $i++;
		?>
			<td>
			    <?php print $rrd['name_cache'];?>
			</td>
			<td style="<?php print get_checkbox_style();?>" width="1%" align="right">
			    <input type='checkbox' style='margin: Opx;' name='chk_<?php print $rrd["id"];?>' title="Select">
			
			</td>
		    </tr>
		<?php
	}
    }else {
	print "<tr><td><em>No more data items available in this selection. Select \"List data items\".</em></td></tr>\n";
    }    
    html_end_box();

    ?>
	<table width='98%' align='center'>
    	    <tr>
		<td align='left'>
		    <img type="image" src='../../images/arrow.gif' alt='Add' align='absmiddle' border='0'>
		</td>
		<td align='right'>
		    <input type="image" name="save" src='../../images/button_add.gif' alt="Add" align="absmiddle">
		</td>
    	    </tr>
        </form>
    <?php
    html_graph_end_box(); 
}


function standard() {
    
    global $colors, $rrdlist_actions;

    $sql = "SELECT  a.id,
		    a.start_day,
		    a.end_day,
		    a.start_time,
		    a.end_time,
		    a.timezone,
		    b.name_cache
	    FROM 
	    	reportit_rrdlist_" . $_GET['id'] ." AS a
	    LEFT JOIN
		data_template_data AS b
	    ON
	    	b.local_data_id = a.id
	    ORDER BY 
	    	b.name_cache";
    
    $rrdlist 		= db_fetch_assoc($sql);
    $number_of_items 	= count($rrdlist);

    
    $report_data		= db_fetch_row('SELECT * FROM reportit_reports WHERE id=' . $_GET['id']);    
    $header_label 		= "[Report: {$report_data['description']}] [$number_of_items]";

    html_start_box("<strong>Data Items </strong> $header_label", "98%", $colors["header"], "2", "center", "cc_rrdlist.php?action=rrdlist_add&id=" . $_GET['id'] );
    html_header_checkbox(array("Description", "Shifttime (from - to)", "Weekdays (from - to)", "Timezone"));

    //Put report_id into hidden state
    print"<tr><td><input type='hidden' name='report_id' value='" . $_GET['id'] . "'></td></tr>";	
    

    
    $i = 0;
    
    if (sizeof($rrdlist) > 0) {
	foreach($rrdlist as $rrd) {
	    form_alternate_row_color($colors["alternate"], $colors["light"], $i); $i++;
		?>
		<td>
			<a class='linkEditMain' href="cc_rrdlist.php?action=rrdlist_edit&id=<?php print $rrd['id'];?>&report_id=<?php print $_GET['id'];?>">
			<?php print $rrd['name_cache'];?>
			</a>
		</td>
		<td>
			<?php print "{$rrd['start_time']}" . " - " . "{$rrd['end_time']}";?>
		</td>
		<td>
			<?php print "{$rrd['start_day']}" . " - " . "{$rrd['end_day']}";?>
		</td>
		<td>
			<?php print $rrd['timezone'];?>
		</td>
		<td style="<?php print get_checkbox_style();?>" width="1%" align="right">
			<input type='checkbox' style='margin: Opx;' name='chk_<?php print $rrd["id"];?>' title="Select">
			
		</td>
	    </tr>
	    <?php
	}
    }else {
	print "<tr><td><em>No data items have been selected. Click \"Add\".</em></td></tr>\n";
    }
    html_end_box();
    draw_actions_dropdown($rrdlist_actions);     
}


function rrdlist_edit() {

    global $colors, $timezone, $shifttime, $shifttime2, $weekday;

    /* ================= input validation ================= */
    input_validate_input_number(get_request_var('id'));
    /* ==================================================== */
		
    $sql = "SELECT  a.id,
		    a.start_day,
		    a.end_day,
		    a.start_time,
		    a.end_time,
		    a.timezone,
		    b.name_cache
	    FROM 
	    	reportit_rrdlist_" . $_GET['report_id'] . " AS a
	    LEFT JOIN
		data_template_data AS b
	    ON
	    	b.local_data_id = a.id
	    WHERE 
	    	a.id =" . $_GET['id'];

    $rrdlist_data		= db_fetch_row($sql);
    $header_label 		= '[edit: ' . $rrdlist_data['name_cache'] . ']';
        
    html_start_box("<strong>Data item</strong> $header_label", "98%", $colors["header"], "2", "center", "");
        $timezone_array = array(
			'rrdlist_timezone'		=> array(
			    'friendly_name'		=> 'Timezone',
			    'method'			=> 'drop_array',
			    'default'			=> '17',
			    'description'		=> 'Select the timezone your following shifttime informations will be based on',
			    'value'			=> array_search($rrdlist_data['timezone'], $timezone),
			    'array'			=> $timezone
			    )
	    		);

    draw_edit_form(array(
			'config' => array(),
			'fields' => $timezone_array
			));
    html_end_box();    
	
    html_start_box("<strong>Working Time</strong>", "98%", $colors["header"], "2", "center", "");
    
    $shift_array = array(
	    		'id'				=> array(
			    'method'			=> 'hidden_zero',
			    'value'			=> $_GET['id']
			    ),
			'report_id'			=> array(
			    'method'			=> 'hidden_zero',
			    'value'			=> $_GET['report_id']
			    ),
			'rrdlist_shifttime_start'	=> array(
			    'friendly_name'		=> 'From',
			    'method'			=> 'drop_array',
			    'default'			=> '0',
			    'description'		=> 'The startpoint of duration you want to analyse',
			    'value'			=> array_search($rrdlist_data['start_time'], $shifttime),
			    'array'			=> $shifttime
			    ),
			'rrdlist_shifttime_end'		=> array(
			    'friendly_name'		=> 'To',
			    'method'			=> 'drop_array',
		    	    'default'			=> '287',
		    	    'description'		=> 'The end of analysing time.',
		    	    'value'			=> array_search($rrdlist_data['end_time'], $shifttime2),
		    	    'array'			=> $shifttime2
		    	    )
	    		);

    draw_edit_form(array(
			'config' => array(),
			'fields' => $shift_array
			));
    html_end_box();
    
    html_start_box("<strong>Working Days</strong>", "98%", $colors["header"], "2", "center", "");
    
    $weekday_array = array(
			'rrdlist_weekday_start'		=> array(
			    'friendly_name'		=> 'From',
			    'method'			=> 'drop_array',
			    'default'			=> '0',
			    'description'		=> 'Define the band of days where shift STARTS!',
			    'value'			=> array_search($rrdlist_data['start_day'], $weekday),
			    'array'			=> $weekday
			    ),
			'rrdlist_weekday_end'		=> array(
			    'friendly_name'		=> 'To',
			    'method'			=> 'drop_array',
		    	    'default'			=> '6',
		    	    'description'		=> 'Example: For a nightshift from Mo(22:30) till Sat(06:30) define Monday to Friday',
		    	    'value'			=> array_search($rrdlist_data['end_day'], $weekday),
		    	    'array'			=> $weekday
		    	    )
	    		);

    draw_edit_form(array(
			'config' => array(),
			'fields' => $weekday_array
			));
    html_end_box();
    
    form_save_button("cc_rrdlist.php?&id={$_GET['report_id']}");

}


function form_actions() {

    global $colors, $rrdlist_actions;

    if (isset($_POST['selected_items'])) {
	$selected_items = unserialize(stripslashes($_POST['selected_items']));

	if ($_POST['drp_action'] == '1') { // Remove RRD from RRD table
	
	    $sql = 'SELECT id FROM reportit_rrdlist_' . $_POST['id'] . ' WHERE ' . array_to_sql_or($selected_items, 'id');

	    $rrdlist_datas = db_fetch_assoc($sql);

	    if (sizeof($rrdlist_datas) > 0) {
		foreach ($rrdlist_datas as $rrdlist_data) {
		    db_execute('DELETE FROM reportit_rrdlist_' . $_POST['id'] . ' WHERE id=' . $rrdlist_data['id']);
		    //Reset report
		    reset_report($_POST['id']);
		}
	    }
	}elseif ($_POST['drp_action'] == '2') { //Copy RRD's reference settings to all other RRDs
	    $reference_items = unserialize(stripslashes($_POST['reference_items']));
	    db_execute("UPDATE 
			    reportit_rrdlist_{$_POST['id']}
		        SET
			    start_day  = '{$reference_items[0]['start_day'] }',
			    end_day    = '{$reference_items[0]['end_day']   }',
			    start_time = '{$reference_items[0]['start_time']}',
			    end_time   = '{$reference_items[0]['end_time']  }',
			    timezone   = '{$reference_items[0]['timezone']  }'");
	    //Reset report
	    reset_report($_POST['id']);
	}	
	header("Location: cc_rrdlist.php?id={$_POST['id']}");
	exit;
    }

    //Set preconditions
	$ds_list = ''; $i = 0;

    foreach($_POST as $key => $value) {
    
	if(strstr($key, 'chk_')) {
	    //Fetch rrd id
	    $id = substr($key, 4);
	    $rrd_ids[] = $id;
	    // ================= input validation =================
			input_validate_input_number($id);
	    // ==================================================== 
	    
	    //Fetch rrd description
	    $rrd_description 	= db_fetch_cell('SELECT b.name_cache FROM reportit_rrdlist_' . $_POST['report_id'] . ' AS a 
						 LEFT JOIN
						    data_template_data AS b
						 ON
						    b.local_data_id = a.id
						 WHERE a.id=' . $id);
	    $ds_list[$rrd_description] = '';
	}
    }

    include_once('./include/top_header.php');
    html_start_box("<strong>" . $rrdlist_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "2", "center", "");
    print "<form action='cc_rrdlist.php' method='post'>\n";

    if ($_POST['drp_action'] == '1') { //DELETE REPORT
	print "	<tr>
		    <td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
			<p>Are you sure you want to remove the following data item(s) from the selection table?<br>
			</p>";
			if(is_array($ds_list)) {
			    print "Data item(s):";
			    foreach($ds_list as $key => $value) {
				print "<li><b>$key</b><br>";
			    }
			    print "</li>";
			}
	print "     </td>
		</tr>\n";
	
    }elseif ($_POST['drp_action'] == '2') { // Copy the settings from selected RRD to all
	//Select the first selected checkbox as reference. The others will be ignored.
	//Fetch first's settings
	
	if(isset($rrd_ids[0])) {
	
	$rrd_settings = db_fetch_assoc('SELECT
					    b.name_cache, 
					    a.*
					FROM
					    reportit_rrdlist_' . $_POST['report_id'] . ' AS a
					LEFT JOIN   
					    data_template_data as b
					ON
					    b.local_data_id = a.id
					WHERE a.id=' . $rrd_ids[0]);
	print "	<tr>
		    <td class='textArea' bgcolor='#" . $colors['form_alternate1']. "'>
			<p>When you click \"yes\", the following settings will be copied to all the other data items of your selection table.     
			</p>";
			    print "Selected data item as reference:";
			    print "<b><br>&#160 {$rrd_settings[0]['name_cache']}</b><p></p>";
			    print "Timezone:<br>&#160 <b>{$rrd_settings[0]['timezone']}</b><p></p>";
			    print "Weekdays:<br>&#160 <b>{$rrd_settings[0]['start_day']} - {$rrd_settings[0]['end_day']}</b><p></p>";     
			    print "Shifttime:<br>&#160 <b>{$rrd_settings[0]['start_time']} - {$rrd_settings[0]['end_time']}</b><p></p>";
	print "	    </td>
		</tr>\n";
	}
    }
    
    if (!is_array($ds_list)) {
	print "<tr><td bgcolor='#" . $colors['form_alternate1']. "'><span class='textError'>You must select at least one report.</span></td></tr>\n";
	$save_html = '';
    }else {
	$save_html = "<input type='image' src='../../images/button_yes.gif' alt='Save' align='absmiddle'>";
    }

    print " <tr>
		<td align='right' bgcolor='#eaeaea'>
		    <input type='hidden' name='id' value='" . $_POST['report_id'] . "'>		
		    <input type='hidden' name='action' value='actions'>
		    <input type='hidden' name='selected_items' value='" . (isset($rrd_ids) ? serialize($rrd_ids) : '') . "'>
		    <input type='hidden' name='reference_items' value='" . (isset($rrd_settings) ? serialize($rrd_settings) : '') . "'>
		    <input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
		    <a href='cc_rrdlist.php?id=" . $_POST['report_id'] . "'><img src='../../images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
		    $save_html
		</td>
	    </tr>";
    
    html_end_box();
    include_once('./include/bottom_footer.php');}
?>