<?php
/*
 +----------------------------------------------------------------------+
 | Copyright (C) 2006 Andreas Braun                                   	|
 |									|
 | This program is free software. You can redistribute it		|
 | and/or modify it under the terms of the GNU General Public License	|
 | as published by the Free Software Foundation; either version 2       |
 | of the License, or (at your option) any later version.               |
 |                                                                      |
 | This program is distributed in the hope that it will be useful, but  |
 | WITHOUT ANY WARRANTY; without even the implied warranty of     	|
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
 | GNU General Public License for more details.     			|
 |                    							|
 +----------------------------------------------------------------------+
*/

chdir('../../');

$guest_account = true;

include ('./include/auth.php');
include_once('./plugins/reportit/lib_int/funct_shared.php');
include_once('./plugins/reportit/lib_int/const_runtime.php');
include_once('./plugins/reportit/lib_int/funct_calculate.php');
include_once('./plugins/reportit/lib_int/funct_runtime.php');
include_once('./plugins/reportit/runtime.php');


//Set default action
if (!isset($_REQUEST['action'])) {
    $_REQUEST['action'] = "";
}


//Redirection
if (isset($_SESSION['run']) && ($_SESSION['run'] == '0')) {
    header("Location: cc_reports.php");
    exit;
}



switch ($_REQUEST['action']) {
    case 'calculation':
	include_once($config['include_path'] . '/top_header.php');    
	calculation();
	include_once($config['include_path'] . '/bottom_footer.php');
	break;
    default:
	break;
}


function calculation() {

    global $colors;
    
    //Start calculation!
    $result = runtime($_GET['id']);
    $_SESSION['run'] = '0';
        
    $sql = "SELECT 
		a.description, a.last_run, a.runtime
	    FROM
		reportit_reports AS a
	    WHERE
		a.id ='{$_GET['id']}'";

    $report_informations = db_fetch_row($sql);


    $number_of_warnings = 0;
    $number_of_errors 	= 0;
    $runtime		= '';
	
    foreach($result as $notice) {
        if(substr_count($notice, 'WARNING')) {
    	    $number_of_warnings++;
	    continue;
	}
	if(substr_count($notice, 'ERROR')) {
	    $number_of_errors++;
	    }
    }


    if(!isset($result['runtime'])) {
	
	?>
	<table align="center" width="98%" cellpadding="3" cellspacing="1" border="0" bgcolor="<?php print $colors["header"];?>">
	    <tr>
		<td class="textHeaderDark"><b>Report calculation failed </b>[<?php print $report_informations['description'];?>]</td>
		<td class="textHeaderDark" align="right">
		    <b><a class="linkOverDark" href="cc_rrdlist.php?&id=<?php print $_GET['id'];?>">Show RRD list</a></b></td>
	    </tr>
	</table>
	<?php 

    }else {

	$runtime = $result['runtime'];
	?>
	<form method='POST' action='cc_view.php?action=show_report&id=<?php print $_GET['id'];?>'>
	<table align="center" width="98%" cellpadding="3" cellspacing="1" border="0" bgcolor="<?php print $colors["header"];?>">
	    <tr>
		<td class="textHeaderDark"><b>Report statistic </b>[<?php print $report_informations['description'];?>]</td>
		<td class="textHeaderDark" align="right">
		    <b><a class="linkOverDark" href="cc_reports.php">Back to report list</a></b></td>
	    </tr>
	</table>
	<?php 
	html_graph_start_box();    
	?>
	    <tr>
		<td>
		    <b>
			Runtime:&nbsp;
			<font color="0000FF">
		    	    <?php print $runtime; ?>s
			</font>
		    </b>
		</td>
	    </tr>
	<?php
	html_graph_end_box(); 
    }


    if($number_of_errors > 0) {
        html_graph_start_box();
	?>
	    <tr>
		<td valign="top">
		    <b>
		        Number of errors
		        <font color="0000FF">
				<?php print "($number_of_errors):"; ?>
		        </font>
		    </b>
		</td>
		<td align="left">
		    <b>
		        <font color="FF0000">
			    <?php
				foreach($result as $error) {
				    if(substr_count($error, 'ERROR')) echo "<li>$error";
				}
			    ?>
			</font>
		    </b>
		</td>
	    </tr>
	<?php
	    
     html_graph_end_box();    
    }

    if($number_of_warnings > 0) {
        html_graph_start_box();
	    
        ?>
	    <tr>
		<td valign="top">
		    <b>
		        Number of warnings
		        <font color="0000FF">
				<?php print "($number_of_warnings):"; ?>
		        </font>
		    </b>
		</td>
		<td align="left">
		    <b>
		        
			    <?php
				foreach($result as $warning) {
				   if(substr_count($warning, 'WARNING')) echo "<li>$warning";
				}
			    ?>
			
		    </b>
		</td>
	    </tr>
	    <?php
	    
	 html_graph_end_box();    
    }

    if($number_of_errors == 0) {    
	?>
	<table width='98%' align='center'>
    	    <tr>
		<td align='left'>
		    <img type="image" src='../../images/arrow.gif' align='absmiddle' border='0'>
		</td>
		<td align='right'>
		    <input type="image" name="view" src='../../images/button_view.gif' alt="View report" align="absmiddle">
		</td>
    	    </tr>
        </form>
	<?php
    }
}    
?>