<?php
/*
 +----------------------------------------------------------------------+
 | Copyright (C) 2006 Andreas Braun                                   	|
 |									|
 | This program is free software. You can redistribute it		|
 | and/or modify it under the terms of the GNU General Public License	|
 | as published by the Free Software Foundation; either version 2       |
 | of the License, or (at your option) any later version.               |
 |                                                                      |
 | This program is distributed in the hope that it will be useful, but  |
 | WITHOUT ANY WARRANTY; without even the implied warranty of     	|
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
 | GNU General Public License for more details.     			|
 |                    							|
 +----------------------------------------------------------------------+
*/

chdir('../../');


$guest_account = true;

include ('./include/auth.php');
include_once('./plugins/reportit/lib_int/funct_shared.php');
include_once('./plugins/reportit/lib_int/const_templates.php');
include_once('./plugins/reportit/lib_int/funct_online.php');
include_once('./plugins/reportit/lib_int/var_templates.php');


$template_actions = array(
    1 => 'Delete',
    2 => 'Duplicate'
    );

//Set default action
if (!isset($_REQUEST['action'])) {
    $_REQUEST['action'] = "";
}

switch ($_REQUEST['action']) {
    case 'actions':
	form_actions();
	break;
    case 'template_edit':
	include_once($config['include_path'] . '/top_header.php');    
	template_edit();
	include_once($config['include_path'] . '/bottom_footer.php');
	break;
    case 'save':
	form_save();
	break;
    default:
	include_once($config['include_path'] . '/top_header.php');
	standard();
	include_once($config['include_path'] . '/bottom_footer.php');
	break;
}


function standard() {

    global $colors, $template_actions;
    
    //Select every report with regard to the ownership
    $myId	  = my_id();
    $myName 	  = my_name();
    $reportAdmin  = re_admin();
    
    $sql = 'SELECT 
		a.id, a.description, b.description AS function, c.type, a.user_id
	    FROM
		reportit_templates AS a
	    LEFT JOIN
		reportit_functions AS b
	    ON
		b.id = a.function_id
	    LEFT JOIN
		reportit_types AS c
	    ON
		c.id = a.type_id';
    
    if ($reportAdmin) {
	$sql = $sql . ' ORDER BY a.user_id, a.description ASC';
	$report_list = db_fetch_assoc($sql);
    }else {
	$sql = $sql . " WHERE a.user_id = '$myId' ORDER BY a.user_id, a.description ASC";
	$report_list = db_fetch_assoc($sql);
    }
        
    $i = 0;
    
    //Number of templates
    $number_of_templates = count($report_list);

    
    html_start_box("<strong>Report Templates </strong>[$number_of_templates]", "98%", $colors["header"], "2", "center", "cc_templates.php?action=template_edit");

    if ($reportAdmin) {
        html_header_checkbox(array('Template Name', 'Owner', 'Function', 'Type'));
    }else {
        html_header_checkbox(array('Template Name', 'Function', 'Type'));
        }    
    
    if (sizeof($report_list) > 0) {
	foreach($report_list as $report) {
	    form_alternate_row_color($colors['alternate'], $colors['light'], $i); $i++;
		?>
		<td>
			<a class='linkEditMain' href="cc_templates.php?action=template_edit&id=<?php print $report['id'];?>">
			    <?php print "{$report['description']}";?>
			</a>
		</td>
		<?php
		//Show all owners to admin
		if ($reportAdmin) {
		    ?><td><?php
		    $ownerId = $report['user_id'];
		    if ($reportAdmin AND $ownerId != $myId) {
			print other_name($ownerId);
		    }else {
			print $myName;
		    }
		    ?></td><?php
		}
		?>
		<td>
			<?php print $report['function'];?>
		</td>
		<td>
			<?php print $report['type'];?>
		</td>
		<td style="<?php print get_checkbox_style();?>" width="1%" align="right">
			<input type='checkbox' style='margin: Opx;' name='chk_<?php print $report["id"];?>' title="Select">
			
		</td>
	    </tr>
	    <?php
	}
    }else {
	print "<tr><td><em>No templates</em></td></tr>\n";
    }  
    html_end_box(true);
    draw_actions_dropdown($template_actions);
}


function form_save() {
    
    global $colors, $form_array_vars;

    /* ================= input validation ================= */
    input_validate_input_number(get_request_var('id'));
    input_validate_input_number(get_request_var('user_id'));    
    input_validate_input_number(get_request_var('template_description'));
    input_validate_input_number(get_request_var('template_function'));
    input_validate_input_number(get_request_var('template_type'));
    input_validate_input_number(get_request_var('threshold'));
    /* ==================================================== */    
    
    $template_data['id']	  = $_POST['id'];
    $template_data['description'] = form_input_validate($_POST['template_description'], 'template_description',NULL ,false,3);
    $template_data['function_id'] = $_POST['template_function']+1;

    If(isset($_POST['template_type'])) {
	$template_data['type_id'] = $_POST['template_type']+1;
    }

    $template_data['user_id']	  = $_POST['user_id'];
    
    if(is_error_message()) {
	header('Location: cc_templates.php?action=template_edit&id=' . $_POST['id']);
    }else {
	//Save template data
	sql_save($template_data, 'reportit_templates');
        
	//Save threshold variable	
	if($_POST['id'] == 0) {
	    $template_id = db_fetch_insert_id();
	}else {
	    $template_id = $_POST['id'];
	}

	$variable_id = db_fetch_cell("SELECT id FROM reportit_variables WHERE template_id ='$template_id'
									AND   field_name  ='threshold'");
								
	$sql = "REPLACE reportit_variables SET 	id	    ='$variable_id',
						template_id ='$template_id',
						field_name  ='threshold',
						value 	    ='{$form_array_vars['threshold']['array'][$_POST['threshold']]}'";
	db_execute($sql);
    	
	//Return to list view if it was an existing report template
	if($_POST['id']!='0') {
	    raise_message(1);    
	    header('Location: cc_templates.php');
	}else {
	    header('Location: cc_templates.php?action=template_edit&id=' . $template_id);
	}
    }
}


function template_edit() {

    global $colors, $calc_functions, $interface_types, $form_array_vars;

    /* ================= input validation ================= */
    input_validate_input_number(get_request_var('id'));
    /* ==================================================== */

    if (!empty($_GET['id'])) {
		
	$template_data		= db_fetch_row  ('SELECT * FROM reportit_templates WHERE id=' . $_GET['id']);
	$template_variables	= db_fetch_assoc('SELECT * FROM reportit_variables WHERE template_id=' . $_GET['id']);
	$header_label 		= '[edit: ' . $template_data['description'] . ']';

	?>
	    <table width="98%" align="center">
		<tr>
		    <td class="textinfo" valign="top" align="right">
			<span style="color: #c16821;">*</span><a href="cc_reports.php?action=report_edit">Create a new report</a>
		    </td>
		</tr>
	    </table><br>
	<?php

    }else {
	$header_label 		= '[new]';
    }
	
    //Set preconditions
    if(isset($template_data)) {
	$template_data['function_id'] -=1;
	$template_data['type_id']     -=1;
    }
    
    if(isset($template_variables)) {
	$variables = array();
	foreach($template_variables as $key => $value) {
    	    $variables += array($template_variables[$key]['field_name'] => $template_variables[$key]['value']);
        }		
    }
    	
    html_start_box("<strong>Report Template</strong> $header_label", "98%", $colors["header"], "2", "center", "");
	
    $form_array = array(
	    		'id'			=> array(
			    'method'		=> 'hidden_zero',
			    'value'		=> (isset($_GET['id']) ? $_GET['id'] : '0')
			    ),
			'user_id'		=> array(
			    'method'		=> 'hidden_zero',
			    'value'		=> (isset($template_data['user_id']) ? $template_data['user_id'] : my_id())
			    ),
			'template_description'	=> array(
			    'friendly_name' 	=> 'Name',
		            'method' 		=> 'textbox',
			    'max_length'	=> '100',
			    'description'	=> 'The name given to this report template',
			    'value' 		=> (isset($template_data['description']) ? $template_data['description'] : '')
			    ),
			'template_function'	=> array(
			    'friendly_name'	=> 'Calculation Function',
			    'method'		=> 'drop_array',
			    'default'		=> 'Null',
			    'description'	=> 'The calculation function for your report template',
			    'value'		=> (isset($template_data['function_id']) ? $template_data['function_id'] : ''),
			    'array'		=> $calc_functions
			    ),
			'template_type'		=> array(
			    'friendly_name'	=> 'Pre-Select',
			    'method'		=> 'drop_array',
		    	    'default'		=> 'Null',
		    	    'description'	=> 'The pre-selection of data sources which could be included in reports.',
		    	    'value'		=> (isset($template_data['type_id']) ? $template_data['type_id'] :''),
		    	    'array'		=> $interface_types,
		    	    )
	    		);
	
    //Report template
    draw_edit_form(array(
			'config' => array(),
			'fields' => $form_array
			));

    
    html_end_box();

    html_start_box("<strong>Variables</strong>", "98%", $colors["header"], "2", "center", "");
	
    //Update $form_array_vars with values from database 
    if (isset($template_variables)) {
        foreach($variables as $field_name => $value) {
	    $form_array_vars[$field_name]['value']	= array_search($value, $form_array_vars[$field_name]['array']);
    	}
    
    }
	
    //Report variables
    draw_edit_form(array(
			'config' => array(),
			'fields' => $form_array_vars
			));
    
    //If there are some reports depending on this templates, we can not change template type. (RRDlists will become invalid!)
    if(!empty($_GET['id'])) {    
	$number_of_reports = db_fetch_assoc("SELECT b.id FROM reportit_templates AS a 
					     LEFT JOIN reportit_reports AS b
				    	     ON b.template_id = a.id
				             WHERE a.id = {$_GET['id']}");
	$var = count($number_of_reports);
	if($number_of_reports > 0 && $number_of_reports[0]['id'] != NULL) {    
	    ?>
	    <script language="JavaScript">
		document.getElementById('template_type').disabled="disabled";
	    </script>
	    <?php
	}
    }

    html_end_box();
    form_save_button('cc_templates.php');
}


function form_actions() {

    global $colors, $template_actions;

    if (isset($_POST['selected_items'])) {
	$selected_items = unserialize(stripslashes($_POST['selected_items']));

	if ($_POST['drp_action'] == '1') { // DELETE REPORT TEMPLATE
	    $template_datas = db_fetch_assoc('SELECT id FROM reportit_templates WHERE ' . array_to_sql_or($selected_items, 'id'));
	    
	    if (sizeof($template_datas) > 0) {
		foreach ($template_datas as $template_data) {
		    db_execute('DELETE FROM reportit_templates WHERE id=' . $template_data['id']);
		    db_execute('DELETE FROM reportit_variables WHERE template_id=' . $template_data['id']);
		    
		    $template_reports = db_fetch_assoc('SELECT id FROM reportit_reports WHERE template_id =' .$template_data['id']);
		    
		    if(is_array($template_reports)) {
			foreach($template_reports as $template_report) {
			    db_execute('DELETE FROM reportit_reports WHERE id=' . $template_report['id']);
			    db_execute('DROP TABLE IF EXISTS reportit_rrdlist_' . $template_report['id']);
			    db_execute('DROP TABLE IF EXISTS reportit_results_' . $template_report['id']);
			}
		    }
		}
	    }
	}elseif ($_POST['drp_action'] == '2') { //DUPLICATE REPORT TEMPLATE
	
	    for ($i=0;($i<count($selected_items));$i++) {
		/* ================= input validation ================= */
		input_validate_input_number($selected_items[$i]);
		/* ==================================================== */
		
		$template_data = db_fetch_row('SELECT * FROM reportit_templates WHERE id = ' . $selected_items[$i]);  
		$template_data['id'] = 0;
		$template_data['description'] = str_replace("<template_title>", $template_data['description'], $_POST['template_addition']);
		sql_save($template_data, 'reportit_templates');
		
		//Duplicate template's variables

		//Get new template id first
		$template_id = db_fetch_insert_id();
		//Get all variable from original template
		$template_variables = db_fetch_assoc('SELECT * FROM reportit_variables WHERE template_id = ' . $selected_items[$i]);
		foreach($template_variables as $variable) {
		    $sql = "REPLACE reportit_variables SET  id		= 0,
							    template_id = '$template_id',
							    field_name  = '{$variable['field_name']}',
							    value 	= '{$variable['value']}'";
		    db_execute($sql); 
		}
	    }
	}
	header('Location: cc_templates.php');
	exit;
    }

    //Set preconditions
	$ds_list = ''; $i = 0;

    foreach($_POST as $key => $value) {
	
	if(strstr($key, 'chk_')) {
	    //Fetch template id
	    $id = substr($key, 4);
	    $template_ids[] = $id;
	    // ================= input validation =================
			input_validate_input_number($id);
	    // ==================================================== 
	    
	    //Fetch Template description
	    $template_description 	= db_fetch_cell('SELECT description FROM reportit_templates WHERE id=' . $id);
	    $ds_list[$template_description] = '';
	    
	    //Fetch all descriptions of reports attached to this template
	    $template_reports		= db_fetch_assoc('SELECT description FROM reportit_reports WHERE template_id=' . $id);
		    	    
	    foreach ($template_reports as $key => $value) {
		$ds_list[$template_description][] = $template_reports[$key]['description'];
	    }
	}
    }

    include_once('./include/top_header.php');
    html_start_box("<strong>" . $template_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "2", "center", "");
    print "<form action='cc_templates.php' method='post'>\n";

    if ($_POST['drp_action'] == '1') { //DELETE REPORT TEMPLATE
	print "	<tr>
		    <td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
			<p>Are you sure you want to delete the following report templates?<br><br>
			    <b>
				WARNING:<br>
				Any report attached to these templates will be deleted too!
			    </b>
			</p>";
			if(is_array($ds_list)) {
			    foreach($ds_list as $key => $value) {
				print "<p>Template : <b>$key</b><br>";
				
				if(is_array($ds_list[$key])) {
				    foreach($ds_list[$key] as $report_name => $value) {
					print "&#160 |_Report:<i> $value</i><br>";
				    }
				    print "<p>";
				}
			    }
			}
	print "     </td>
		</tr>\n";
	
    }elseif ($_POST['drp_action'] == '2') { // DUPLICATE REPORT TEMPLATE
	print "	<tr>
		    <td class='textArea' bgcolor='#" . $colors['form_alternate1']. "'>
			<p>When you click yes, the following report templates will be duplicated. You can
			   optionally change the title for the new report templates.
			</p>";
			if(is_array($ds_list)) {
			    print "Template(s):";
			    foreach($ds_list as $key => $value) {
				print "<li><strong>$key</strong></li><br>";
			    }
			}		
			print "<p><strong>Title:</strong><br>"; 
			form_text_box("template_addition", "<template_title> (1)", "", "255", "30", "text");
	print "		</p>
		    </td>
		</tr>\n";
    }
    
    if (!is_array($ds_list)) {
	print "<tr><td bgcolor='#" . $colors['form_alternate1']. "'><span class='textError'>You must select at least one report template.</span></td></tr>\n";
	$save_html = '';
    }else {
	$save_html = "<input type='image' src='../../images/button_yes.gif' alt='Save' align='absmiddle'>";
    }

    print " <tr>
		<td align='right' bgcolor='#eaeaea'>
		    <input type='hidden' name='action' value='actions'>
		    <input type='hidden' name='selected_items' value='" . (isset($template_ids) ? serialize($template_ids) : '') . "'>
		    <input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
		    <a href='cc_templates.php'><img src='../../images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
		    $save_html
		</td>
	    </tr>";
    
    html_end_box();
    include_once('./include/bottom_footer.php');}
?>