<?php
/*
 +----------------------------------------------------------------------+
 | Copyright (C) 2006 Andreas Braun                                   	|
 |									|
 | This program is free software. You can redistribute it		|
 | and/or modify it under the terms of the GNU General Public License	|
 | as published by the Free Software Foundation; either version 2       |
 | of the License, or (at your option) any later version.               |
 |                                                                      |
 | This program is distributed in the hope that it will be useful, but  |
 | WITHOUT ANY WARRANTY; without even the implied warranty of     	|
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
 | GNU General Public License for more details.     			|
 |                    							|
 +----------------------------------------------------------------------+
*/


chdir('../../');

$guest_account = true;

include ('./include/auth.php');
include_once('./plugins/reportit/lib_int/funct_shared.php');
include_once('./plugins/reportit/lib_int/const_view.php');
include_once('./plugins/reportit/lib_int/funct_online.php');
include_once('./plugins/reportit/lib_int/funct_export.php');

if (!isset($_REQUEST["action"])) {
    $_REQUEST["action"] = "";
}

switch ($_REQUEST["action"]) {
    case 'show_report':
	if(only_viewer()) {
	    include_once($config["include_path"] . "/top_graph_header.php");
	}else {
    	    include_once($config["include_path"] . "/top_header.php");
	}
	show_report();
	include_once($config["include_path"] . "/bottom_footer.php");
	break;
    case 'show_graph_overview':
	show_graph_overview();
	break;    
    case 'export':
	export();
	break;
    default:
	if(only_viewer()) {
	    include_once($config["include_path"] . "/top_graph_header.php");
	}else {
    	    include_once($config["include_path"] . "/top_header.php");
	}	
	standard();
	include_once($config["include_path"] . "/bottom_footer.php");
	break;
}


function export() {
    global $colors, $config;
    
    //Fetch export settings (global)
    $export_settings	   = db_fetch_assoc("SELECT * FROM settings WHERE name like '%reportit%'");
    
    //Fetch export settings (user)
    $id 		   = my_id();
    $export_graph_settings = db_fetch_assoc("SELECT name, value FROM settings_graphs WHERE name like '%reportit%' AND user_id = '$id' AND name != 'reportit_exp_header'");

    //Tranform settings
    $export_settings    = array_merge($export_settings, $export_graph_settings);
    $exp_settings	= array();
    foreach($export_settings as $settings) {
	$exp_settings[$settings['name']] = $settings['value'];
    };
    
    //Prepare data for export
    $report_data	= get_prepared_report_data($_GET['id'],'','','export');
    $export_function	= "export_to_{$_GET['type']}";
    
    //Call export function
    $filename 		= $export_function($report_data, $exp_settings);

    header("Location: ./exports/{$_GET['type']}/$filename");  
}
 

function standard() {
    global $colors, $config;
    
    $userid = my_id();
    
    $sql = "SELECT	a.id,
			a.description, 
			a.start_date,
			a.end_date,
			a.last_run,
			b.user_id, 
			b.description 					AS template_description,
			c.type
	    FROM 	reportit_reports 				AS a
	    JOIN	reportit_templates 				AS b
	    ON 		b.id 			= a.template_id
	    JOIN	reportit_types 					AS c
	    ON		c.id			= b.type_id
	    WHERE      (
			    a.public 		= 'on'
			    OR
			    b.user_id 		= $userid
			) 
	    AND		a.last_run 	       != 0";
    
        
    // Check whether user wants to sort view by something
    if(isset($_GET['sort']) && isset($_GET['mode'])) {
	$sql = $sql . " ORDER BY {$_GET['sort']} {$_GET['mode']}";
    }
    $report_list 	= db_fetch_assoc($sql);
    $number_of_reports  = count($report_list);
        
    // Check export types
    $sql 		= "SELECT * FROM settings WHERE name = 'reportit_csv'";
    $export_types	= db_fetch_assoc($sql);
    
    //Tranform settings
    $exp_settings	= array();
    foreach($export_types as $settings) {
	if ($settings['value'] == 'on') {
	    $name = substr($settings['name'], 9);
	    $exp_settings[$name] = $settings['value'];
	}
    }
/*   
    //Check export paths
    foreach($exp_settings as $key => $value) {
	$path = 'reportit_' . $key . '_path';
	if (!read_config_option($path)) {
	    //Remove Index if there no path has been defined
	    unset($exp_settings[$key]);
	}
    }
*/

    $number_of_exp_types= count($exp_settings);

    //----- Start HTML output -----
    html_start_box("<strong>Public Reports</strong> [$number_of_reports]", "98%", $colors["header"], "2", "center", "");
    
    $header = array("Description
		        <a href='cc_view.php?&sort=description&mode=DESC'><font size='2' color='FFFF00'>&#8593</font></a>
		        <a href='cc_view.php?&sort=description&mode=ASC'><font size='2' color='FFFF00'>&#8595</font></a>", 
		      "Owner 
		        <a href='cc_view.php?&sort=user_id&mode=DESC'><font size='2' color='FFFF00'>&#8593</font></a>
		        <a href='cc_view.php?&sort=user_id&mode=ASC'><font size='2' color='FFFF00'>&#8595</font></a>",
		      "Template
		        <a href='cc_view.php?&sort=template_description&mode=DESC'><font size='2' color='FFFF00'>&#8593</font></a>
		        <a href='cc_view.php?&sort=template_description&mode=ASC'><font size='2' color='FFFF00'>&#8595</font></a>",
		      "Type
		        <a href='cc_view.php?&sort=type&mode=DESC'><font size='2' color='FFFF00'>&#8593</font></a>
		        <a href='cc_view.php?&sort=type&mode=ASC'><font size='2' color='FFFF00'>&#8595</font></a>",
		      "Period (from - to)", "Runtime (GMT)");
		      
    if ($number_of_exp_types != 0) {
	$header[]="Export";
    }
    html_header($header);

    // Set preconditions
    $i = 0;
    
    // Build report list
    if (sizeof($report_list) > 0) {
	foreach($report_list as $report) {
	    form_alternate_row_color($colors["alternate"], $colors["light"], $i); $i++;

	    ?>
		    <td>
			<a class='linkEditMain' href="cc_view.php?action=show_report&id=<?php print $report["id"];?>">
			    <?php print $report["description"];?>
			</a>
		    </td>
	    	    <td>
			<?php
			    $ownerId = $report['user_id'];
		    	    print other_name($ownerId);
			?>
		    </td>
		    <td>
			<?php print $report['template_description'];?>
	    	    </td>
    		    <td>
			<?php print $report['type'];?>
		    </td>
		    <td>
			<?php print "{$report['start_date']} - {$report['end_date']}";?>
		    </td>
		    <td>
			<?php print $report['last_run'];?>
		    </td>
			<?php
			if ($number_of_exp_types != 0) {
			    print "<td>";
			    foreach($exp_settings as $key => $value) {
				print "<a class='linkEditMain' href='cc_view.php?action=export&type=$key&id={$report['id']}'>.$key</a>&nbsp;";
			    }
			    print "</td>";
			}
			?>
		</tr>
	    <?php
	    
	}
    }

    html_end_box(true);
    //-----------------------------
}



function show_report() {
    global $colors, $abbreviations;

    // Check whether user wants to sort view by something
    if(isset($_GET['sort']) && isset($_GET['mode'])) {
	$dummy = get_prepared_report_data($_GET['id'], $_GET['sort'], $_GET['mode'], 'view');
    }else {
	$dummy = get_prepared_report_data($_GET['id'],'','','view');
    }
    
    $report_data	= $dummy['report_data'];
    $report_header	= $dummy['report_data']['description'];
    $report_results	= $dummy['report_results'];

    // Extract result description;
    $rs_description 	= explode("|", $report_data['result_description']);
    
    // Extract datasource description;
    $ds_description 	= explode("|", $report_data['ds_description']);

    //Counter
    $counter_rs		= count($rs_description);

    
    //----- Start HTML output -----
    ?>
	<table align="center" width="98%" cellpadding="3" cellspacing="1" border="0" bgcolor="<?php print $colors["header"];?>">
	    <tr>
		<td class="textHeaderDark" align="left">
		    <b>Report&nbsp;</b>
		    <?php print "[$report_header]";?>
		</td>
		<td class="textHeaderDark" align="right">
		    <b>
			<a class="linkOverDark" href="cc_view.php">&raquo;&nbsp;reports</a>
		    </b>
		</td>
	    </tr>
	</table>
	<br>
	<table align="center" width="98%" cellpadding="3" cellspacing="1" border="0" bgcolor="<?php print $colors["header_panel"];?>">
	    <tr>
		<td bgcolor="#E5E5E5"></td>
		    <?php
			foreach($ds_description as $description) {
			    print "<th colspan='$counter_rs' height='10' bgcolor='E5E5E5'>$description</th>";
			}
		    ?>
	    </tr>
	    <tr>
		<td class="textSubHeaderDark" align="left">
		    <b>
			<?php 
			    print "Data Description<br>
				   <a  title='descending' href='cc_view.php?action=show_report&id={$_GET['id']}&sort=name_cache&mode=DESC'><font size='2' color='FFFF00'>&#8593</font></a>
				   <a  title='ascending' href='cc_view.php?action=show_report&id={$_GET['id']}&sort=name_cache&mode=ASC'><font size='2' color='FFFF00'>&#8595</font></a>
				  ";
			?>
		    </b>
		</td>
		    <?php
	    		foreach($ds_description as $datasource) {
	        	    foreach($rs_description as $value) {
	        	    
			    ?>
    				<td class="textSubHeaderDark" align="right">
				    
			    <?php 
				$var = $datasource.'__'.$value;
				if(array_key_exists($value, $abbreviations)) {
				    $title = $abbreviations[$value];
				}else {
				    $title = '';
    				}
				print "<b title='$title'>$value<br>
				       <a title='descending' href='cc_view.php?action=show_report&id={$_GET['id']}&sort=$var&mode=DESC'><font size='2' color='FFFF00'>&#8593</font></a>
		    	    	       <a title='ascending'  href='cc_view.php?action=show_report&id={$_GET['id']}&sort=$var&mode=ASC'><font size='2' color='FFFF00'>&#8595</font></a>
				       </b>";
				      
			    ?>
				</td>
		    	    <?php
			    
			    }
			}
		    ?>
	    </tr>
		<?php	    
		    // Set preconditions
		    $i = 0;

		    if (sizeof($report_results) > 0) {
			foreach($report_results as $result) {
			    form_alternate_row_color($colors["alternate"], $colors["light"], $i); $i++;
		
			    ?>
				<td>
				    <a class='linkEditMain' href="cc_view.php?action=show_graph_overview&id=<?php print $_GET["id"];?>&rrd=<?php print $result["id"];?>">
					<?php print $result["name_cache"];?>
				    </a>
				</td>
			    <?php
		
			    foreach($ds_description as $datasource) {
	        		foreach($rs_description as $description) {
	        	
				    ?>
    					<td align="right" >
				    <?php
				
				    $value = $result[$datasource.'__'.$description];
				    if($value == NULL) {
					print "NA";
				    }elseif ($value == 0) {
					print $value;
				    }else {
					print get_unit($value);
				    }
				    
				    ?>
					</td>
		    		    <?php
			
				}
			    }
			}
		    }
		?>
	</table>
    <?php
}




function show_graph_overview() {

    $sql = "SELECT DISTINCT 	c.local_graph_id    							    
	    FROM 		data_template_data 				AS a
	    JOIN 		data_template_rrd 				AS b
	    ON 			b.local_data_id 	= a.local_data_id
	    JOIN 		graph_templates_item 				AS c
	    ON 			c.task_item_id 		= b.id
	    WHERE 		a.local_data_id 	= {$_GET['rrd']}";
    $local_graph_id = db_fetch_cell($sql);
    
    header("Location: ../../graph.php?local_graph_id=$local_graph_id&rra_id=all");
}

?>