<?php
/*
 +----------------------------------------------------------------------+
 | Copyright (C) 2006 Andreas Braun                                   	|
 |									|
 | This program is free software. You can redistribute it		|
 | and/or modify it under the terms of the GNU General Public License	|
 | as published by the Free Software Foundation; either version 2       |
 | of the License, or (at your option) any later version.               |
 |                                                                      |
 | This program is distributed in the hope that it will be useful, but  |
 | WITHOUT ANY WARRANTY; without even the implied warranty of     	|
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
 | GNU General Public License for more details.     			|
 |                    							|
 +----------------------------------------------------------------------+
*/



// ----- CONSTANTS FOR: runtime.php -----


// $timezones : 	- multidimensional array
//			- contains all standard timezones and includes the offset to GMT
$timezones = array(
    'AEDT (GMT+11 )'  =>array('hour' => 11, 'min' =>  0),
    'ACDT (GMT+10.5)' =>array('hour' => 10, 'min' => 30),
    'AEST (GMT+10 )'  =>array('hour' => 10, 'min' =>  0),
    'ACST (GMT+09.5)' =>array('hour' =>  9, 'min' => 30),
    ' JST (GMT+09 )'  =>array('hour' =>  9, 'min' =>  0),
    ' ROK (GMT+09 )'  =>array('hour' =>  9, 'min' =>  0),
    ' SST (GMT+08 )'  =>array('hour' =>  8, 'min' =>  0),
    ' THA (GMT+07 )'  =>array('hour' =>  7, 'min' =>  0),
    ' IST (GMT+05.5)' =>array('hour' =>  5, 'min' => 30),
    'EEST (GMT+03)'   =>array('hour' =>  3, 'min' =>  0),
    'MEST (GMT+02)'   =>array('hour' =>  2, 'min' =>  0),
    ' EET (GMT+02)'   =>array('hour' =>  2, 'min' =>  0),
    'CEST (GMT+02)'   =>array('hour' =>  2, 'min' =>  0),
    ' BST (GMT+01)'   =>array('hour' =>  1, 'min' =>  0),
    ' CET (GMT+01)'   =>array('hour' =>  1, 'min' =>  0),
    ' MET (GMT+01)'   =>array('hour' =>  1, 'min' =>  0),
    'WEST (GMT+01)'   =>array('hour' =>  1, 'min' =>  0),
    'GMT'             =>array('hour' =>  0, 'min' =>  0),
    ' WET (GMT)'      =>array('hour' =>  0, 'min' =>  0),
    ' BDT (GMT-02)'   =>array('hour' => -2, 'min' =>  0),
    '  BT (GMT-03)'   =>array('hour' => -2, 'min' =>  0),
    ' EDT (GMT-04)'   =>array('hour' => -4, 'min' =>  0),
    ' EST (GMT-05)'   =>array('hour' => -5, 'min' =>  0),
    ' CDT (GMT-05)'   =>array('hour' => -5, 'min' =>  0),
    ' CST (GMT-06)'   =>array('hour' => -6, 'min' =>  0),
    ' MDT (GMT-06)'   =>array('hour' => -6, 'min' =>  0),
    ' MST (GMT-07)'   =>array('hour' => -7, 'min' =>  0),
    ' PDT (GMT-07)'   =>array('hour' => -7, 'min' =>  0),
    ' PST (GMT-08)'   =>array('hour' => -8, 'min' =>  0)
);


$runtime_messages = array(
			    1 => 'REPORTIT ERROR: PHP modul for RRDtool is not available.',
			    2 => 'REPORTIT ERROR: No data items defined. Report[<RID>]',
			    3 => 'REPORTIT ERROR: Startpoint is a part of future. Report[<RID>] Data item[<DID>]',
			    4 => 'REPORTIT ERROR: No valid data found. Check your configuration. Report[<RID>]',
			    5 => 'REPORTIT RRDfetch ERROR: <NOTICE> Report[<RID>] Data Item[<DID>]',
			    6 => 'REPORTIT WARNING: End of working time is a part of future. Can only calculate data till now. Report[<RID>] Data item[<DID>]',
			    7 => 'REPORTIT WARNING: No startpoints available. Check your working days! Report[<RID>] Data item[<DID>]',
			    8 => 'REPORTIT WARNING: No values available. Report[<RID>] Data Item[<DID>]',
			    9 => 'REPORTIT ERROR: Unable to connect to RRDtool server.',
			    );


// $data_source_types	- multidimensional array
//			- contains the relationsship between the names of datasources and the datasource types 
//			  (e.g COUNTER) which are used in CACTI
$data_source_types = db_fetch_assoc("SELECT DISTINCT	data_source_name, data_source_type_id 
     				     FROM	  	data_template_rrd
				     ORDER BY 		data_source_name 	ASC");

?>
