<?php
/*
 +----------------------------------------------------------------------+
 | Copyright (C) 2006 Andreas Braun                                   	|
 |									|
 | This program is free software. You can redistribute it		|
 | and/or modify it under the terms of the GNU General Public License	|
 | as published by the Free Software Foundation; either version 2       |
 | of the License, or (at your option) any later version.               |
 |                                                                      |
 | This program is distributed in the hope that it will be useful, but  |
 | WITHOUT ANY WARRANTY; without even the implied warranty of     	|
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
 | GNU General Public License for more details.     			|
 |                    							|
 +----------------------------------------------------------------------+
*/


function owner($report_id) {
    $owner = db_fetch_cell("SELECT 	username 
			    FROM 	reportit_reports		as a
			    JOIN 	reportit_templates 		as b
			    ON 		a.template_id		= b.id
			    JOIN	user_auth			as c
			    ON		c.id 			= b.user_id
			    WHERE	a.id = $report_id");
    return $owner;
}


function get_prepared_report_data($report_id, $order='description', $mode='ASC', $type) {
    //Prepare all necessary data for export, view or something else
    
    $sql =	"SELECT a.*, b.description as template_name
		 FROM 	reportit_reports 						AS a
		 JOIN	reportit_templates						AS b
		 ON	a.template_id				= b.id
		 WHERE 	a.id					= '$report_id' ";
    $report_data		 = db_fetch_row($sql);
    
    $sql =	"SELECT c.type, d.description
		 FROM 	reportit_reports 						AS a
		 JOIN	reportit_templates						AS b
		 ON	a.template_id				= b.id
		 JOIN	reportit_types							AS c
		 ON	b.type_id 				= c.id
		 JOIN	reportit_functions						AS d
		 ON	b.function_id				= d.id
		 WHERE 	a.id					= '$report_id' ";    
    $report_data['type']	 = db_fetch_row($sql);    
        
    $report_data['owner']	 = owner($report_id);

					
    switch ($type) {
	    case 'view':
			    $sql = "SELECT	a.*,
						b.*,						c.name_cache
				    FROM 	reportit_results_$report_id 			AS a
				    JOIN 	reportit_rrdlist_$report_id 			AS b
				    ON 		a.id 				= b.id
				    JOIN 	data_template_data 				AS c
				    ON 		c.local_data_id 		= a.id
				    ORDER BY    '$order' $mode";
	    break;
	    case 'export':
			    $sql = "SELECT	c.name_cache,
						b.*,
						a.*
				    FROM 	reportit_results_$report_id 			AS a
				    JOIN 	reportit_rrdlist_$report_id 			AS b
				    ON 		a.id 				= b.id
				    JOIN 	data_template_data 				AS c
				    ON 		c.local_data_id 		= a.id

				    ORDER BY    '$order' $mode";
	    break;
    }
    
    $report_results	= db_fetch_assoc($sql);

    $dummy = array( 'report_data'	=> $report_data, 
		    'report_results'	=> $report_results);

return $dummy;
}


function get_timespan($preset_timespan, $present) {

    //Set preconditions
    $today = gmdate("Y-m-d");
    list($ys, $ms, $ds) = explode("-", $today);
    list($ye, $me, $de) = explode("-", $today);    
    
    //Set report start date
    switch ($preset_timespan)  {
	case 'Today':
	    break;
	case 'Last 1 Day':
	    $ds-=1;$de-=1;
	    break;
	case 'Last 2 Days':
	    $ds-=2;$de-=1;	    
	    break;
	case 'Last 3 Days':
	    $ds-=3;$de-=1;	    
	    break;
	case 'Last 4 Days':
	    $ds-=4;$de-=1;
	    break;
	case 'Last 5 Days':
	    $ds-=5;$de-=1;	    
	    break;
	case 'Last 6 Days':
	    $ds-=6;$de-=1;	    
	    break;
	case 'Last 7 Days':
	    $ds-=7;$de-=1;
	    break;	    
	case 'Last 14 Days':
	    $ds-=14;$de-=1;	    
	    break;
	case 'Last 21 Days':
	    $ds-=21;$de-=1;	    
	    break;
	case 'Last 28 Days':
	    $ds-=28;$de-=1;
	    break;
	case 'Current Month':
	    $ds=1;$de-=1;
	    break;
	case 'Last Month':
	    $ms-=1;$ds=1;$de=0;
	    break;
	case 'Last 2 Months':
	    $ms-=2;$ds=1;$de=0;
	    break;
	case 'Last 3 Months':
	    $ms-=3;$ds=1;$de=0;
	    break;
	case 'Last 4 Months':
	    $ms-=4;$ds=1;$de=0;
	    break;
	case 'Last 5 Months':
	    $ms-=5;$ds=1;$de=0;
	    break;
	case 'Last 6 Months':
	    $ms-=6;$ds=1;$de=0;
	    break;
	case 'Current Year':
	    $ms=1;$ds=1;$de-=1;
	    break;	
	case 'Last Year':
	    $ms=1;$ds=1;$ys-=1;$me=1;$de=0;
	    break;
	case 'Last 2 Years':
	    $ms=1;$ds=1;$ys-=2;$me=1;$de=0;
	    break;
	default:
	    break;
    }
    
    $dates = array();
    
    $dates['start_date'] 	= gmdate("Y-m-d", gmmktime(0,0,0, $ms, $ds, $ys));
        
    if($present) {
        $dates['end_date'] 	= $today;	
    }else {
	$dates['end_date'] 	= gmdate("Y-m-d", gmmktime(0,0,0, $me, $de, $ye));    
    }
    
    return $dates;
}


function get_unit($value) {
    switch($value) {
	case ($value >= 1000000000000000000000000):
			//YOTTA
	    $value   /= 1000000000000000000000000;
	    return (sprintf("%01.2f", $value) . " Y");
	    break;
	case ($value >=  100000000000000000000000):
	    $value   /= 1000000000000000000000000;
	    return (sprintf("%01.2f", $value) . " Y");
	    break;
    
	case ($value >=	      1000000000000000000):
			//ZETTA
	    $value   /=       1000000000000000000;
	    return (sprintf("%01.2f", $value) . " Z");
	    break;
	case ($value >=        100000000000000000):
	    $value   /=       1000000000000000000;
	    return (sprintf("%01.2f", $value) . " Z");
	    break;    
	case ($value >=       1000000000000000000):
			//EXA
	    $value   /=       1000000000000000000;
	    return (sprintf("%01.2f", $value) . " E");
	    break;
	case ($value >=        100000000000000000):
	    $value   /=       1000000000000000000;
	    return (sprintf("%01.2f", $value) . " E");
	    break;
    
	case ($value >=          1000000000000000):
			//PETA
	    $value   /=          1000000000000000;
	    return (sprintf("%01.2f", $value) . " P");
	    break;
	case ($value >=           100000000000000):
	    $value   /=          1000000000000000;
	    return (sprintf("%01.2f", $value) . " P");
	    break;
    
	case ($value >=             1000000000000):
			//TERA
	    $value   /=             1000000000000;
	    return (sprintf("%01.2f", $value) . " T");
	    break;
	case ($value >=              100000000000):
	    $value   /=             1000000000000;
	    return (sprintf("%01.2f", $value) . " T");
	    break;
    
	case ($value >=                1000000000):
			//GIGA
	    $value   /=                1000000000;
	    return (sprintf("%01.2f", $value) . " G");
	    break;
	case ($value >                  100000000):
	    $value   /=                1000000000;
	    return (sprintf("%01.2f", $value) . " G");
	    break;
	    	    
	case ($value >=                   1000000):
			//MEGA
	    $value   /=                   1000000;
	    return (sprintf("%01.2f", $value) . " M");
	    break;
	case ($value >                     100000):
	    $value   /=                   1000000;
	    return (sprintf("%01.2f", $value) . " M");
	    break;
	case ($value >=                      1000):
			//KILO
	    $value   /=                      1000;
	    return (sprintf("%01.2f", $value) . " K");
	    break;
	case ($value >                        100):
	    $value   /=                      1000;
	    return (sprintf("%01.2f", $value) . " K");
	    break;
	default:
	    return sprintf("%01.2f", $value);
	    break;
    }
}


function create_rrd_table($report_id) {
    // Create the sql syntax
    $sql = "CREATE TABLE reportit_rrdlist_" . $report_id . " ( 
	    id 			INT 		PRIMARY KEY,
	    start_day 		VARCHAR(255)	NOT NULL	DEFAULT 'Monday', 
	    end_day 		VARCHAR(255)	NOT NULL	DEFAULT 'Sunday',
	    start_time		TIME		NOT NULL	DEFAULT '00:00:00',
	    end_time		TIME		NOT NULL	DEFAULT '24:00:00',
	    timezone		VARCHAR(255)	NOT NULL	DEFAULT 'GMT'
	    )TYPE=MyISAM";    
    db_execute($sql);
}


function reset_report($report_id) {
    // Set report values last_run and runtime to zero
    db_execute("UPDATE reportit_reports SET last_run = '0', runtime = '0' WHERE id = '$report_id'");
}


?>