<?php
/*******************************************************************************

    Author ......... Andreas Braun
    Contact ........ browniebraun AT web DOT de
    Home Site ...... http://browniebraun.mynetcologne.de
    Program ........ "report it!"
    Version ........ 0.3.2
    Purpose ........ Create printable and exportable Reports

*******************************************************************************/



function plugin_init_reportit() {

    global $plugin_hooks;
    $plugin_hooks['top_header_tabs']	  ['reportit']	= 'reportit_show_tab';
    $plugin_hooks['top_graph_header_tabs']['reportit'] 	= 'reportit_show_tab';
    $plugin_hooks['draw_navigation_text'] ['reportit'] 	= 'reportit_draw_navigation_text';
    $plugin_hooks['config_arrays']	  ['reportit'] 	= 'reportit_config_arrays';
    $plugin_hooks['config_settings']	  ['reportit'] 	= 'reportit_config_settings';

}



function reportit_version () {

    return array('name'     	=> 'report it!',
    		'version'     	=> '0.3.2',
        	'longname'    	=> 'report it!',
        	'author'    	=> 'Andreas Braun',
        	'homepage'    	=> '',
        	'email'    	=> 'browniebraun@web.de',
        	'url'        	=> ''
        	);
}



function reportit_draw_navigation_text ($nav) {

    $nav["cc_reports.php:"] 			= array("title" => "Reports", "mapping" => "index.php:", "url" => "cc_reports.php", "level" => "1");
    $nav["cc_reports.php:report_edit"]		= array("title" => "(Edit)", "mapping" => "index.php:,?", "url" => "cc_templates.php", "level" => "2");
    $nav["cc_reports.php:actions"]		= array("title" => "Actions", "mapping" => "index.php:,?", "url" => "cc_templates.php", "level" => "2");    

    $nav["cc_rrdlist.php:"]			= array("title" => "Data Items", "mapping" => "index.php:,cc_reports.php:", "url" => "cc_templates.php", "level" => "2");
    $nav["cc_rrdlist.php:rrdlist_add"]		= array("title" => "Add", "mapping" => "index.php:,cc_reports.php:,cc_rrdlist.php:", "url" => "", "level" => "3");
    $nav["cc_rrdlist.php:rrdlist_edit"]		= array("title" => "(Edit)", "mapping" => "index.php:,cc_reports.php:,cc_rrdlist.php:", "url" => "", "level" => "3");
    $nav["cc_rrdlist.php:actions"]		= array("title" => "Actions", "mapping" => "index.php:,cc_reports.php:,cc_rrdlist.php:", "url" => "", "level" => "3");
    
    $nav["cc_templates.php:"] 			= array("title" => "Report Templates", "mapping" => "index.php:", "url" => "cc_templates.php", "level" => "1");
    $nav["cc_templates.php:template_edit"] 	= array("title" => "(Edit)", "mapping" => "index.php:,cc_templates.php:", "url" => "", "level" => "2");
    $nav["cc_templates.php:actions"] 		= array("title" => "Actions", "mapping" => "index.php:,cc_templates.php:", "url" => "", "level" => "2");

    $nav["cc_run.php:calculation"] 		= array("title" => "Report Calculation", "mapping" => "index.php:,cc_reports.php:", "url" => "", "level" => "2");
    
    $nav["cc_view.php:"] 			= array("title" => "Public Reports", "mapping" => "index.php:", "url" => "cc_view.php", "level" => "1");
    $nav["cc_view.php:show_report"]		= array("title" => "Show Report", "mapping" => "index.php:,cc_view.php:", "url" => "", "level" => "2");
    
    return $nav;
}



function reportit_config_arrays () {

    global $user_auth_realms, $user_auth_realm_filenames, $menu;

    $realm_id_1 						= 800;
    $realm_id_2 						= 801;
    $realm_id_3 						= 802;
    
    $user_auth_realms[$realm_id_1]				= 'Plugin -> Reports: Power User Configuration';
    $user_auth_realms[$realm_id_2]				= 'Plugin -> Reports: Owner Configuration';
    $user_auth_realms[$realm_id_3]				= 'Plugin -> Reports: View';
        
    $user_auth_realm_filenames['cc_templates.php']		= $realm_id_2;
    $user_auth_realm_filenames['cc_reports.php']		= $realm_id_2;
    $user_auth_realm_filenames['cc_rrdlist.php']		= $realm_id_2;    
    $user_auth_realm_filenames['cc_run.php']			= $realm_id_2;
    $user_auth_realm_filenames['cc_view.php'] 			= $realm_id_3;
        
    $menu["Management"]	['plugins/reportit/cc_reports.php'] 	= "Reports";
    $menu["Templates"]	['plugins/reportit/cc_templates.php']	= "Report Templates";    
    
}



function reportit_config_settings () {

    global $tabs, $tabs_graphs, $settings, $graph_dateformats, $graph_datechar, $settings_graphs;

    $csv_column_seperator 	=  array(",", ";", "Tab", "Blank");
    $csv_decimal_seperator	=  array(",", ".");
    $rrdtool_api		=  array('PHP BINDINGS (FAST)', 'RRDTOOL CACTI (SLOW)', 'RRDTOOL SERVER (SLOW)');

    $tabs["reports"] 		=  "Reports";

    $temp 			=  array(
        "reportit_header"	=> array(
            "friendly_name" 	=> "General",
            "method"		=> "spacer",
            ),
        "reportit_API" 		=> array(
            "friendly_name" 	=> "RRDtool Connection",
            "description" 	=> "Choose the way to connect to RRDtool.",
            "method" 		=> "drop_array",
	    "array"		=> $rrdtool_api,
	    "default"		=> "1",
	    ),
	"reportit_RRDID"	=> array(
	    "friendly_name"	=> "RRDtool Server IP",
	    "description"	=> "Optional: Configured IP address of the RRDtool server.",
	    "method"		=> "textbox",
	    "max_length"	=> "15",
	    "default"		=> "127.0.0.1",
	    ),
	"reportit_RRDPort" 	=> array(
	    "friendly_name"	=> "RRDtool Server Port",
	    "description"	=> "Optional: Configured port setting of RRDtool server.",
	    "method"		=> "textbox",
	    "max_length"	=> "5",
	    "default"		=> "13900",
	    ),	
	"reportit_met"		=> array(
	    "friendly_name"	=> "Maximum Execution Time (in seconds)",
	    "description"	=> "Optional: Maximum execution time of one calculation",
	    "method"		=> "textbox",
	    "max_length"	=> "4",
	    "default"		=> "300",
	    ),
        "reportit_header2"	=> array(
            "friendly_name" 	=> "Export Settings",
            "method"		=> "spacer",
            ),	    	    
        "reportit_csv" 		=> array(
            "friendly_name" 	=> "Enable CSV export",
            "description" 	=> "Enable/disable CSV export functionality",
            "method" 		=> "checkbox",
            "default" 		=> "off",
            ),
        "reportit_filename" 	=> array(
            "friendly_name" 	=> "Filename Format",
            "description" 	=> "The name format for the export files.",
	    "max_length"	=> "100",
            "method" 		=> "textbox",
	    "default"		=> "cacti_report<report_id>",
	    ),	    
	"reportit_exp_header" 	=> array(
            "friendly_name" 	=> "Export Header",
            "description" 	=> "The header description for export files",
            "method" 		=> "textarea",
	    "textarea_rows"	=> "3",
	    "textarea_cols"	=> "60",
	    "default"		=> "# Copyright 2006(c) - ABCDEFG Company. All rights reserved.\n# Performance Management with CACTI\n# <cacti_version> <report_version>",
	    ),		    
    );


    if (isset($settings["reports"]))
        $settings["reports"]=array_merge($settings_graphs, $temp);
    else
        $settings["reports"]=$temp;
    unset($temp);
    
    
	//Extension of graph settings
	$tabs_graphs['reportit']= 'Report Settings';
	    
        $temp 			=  array(
        "reportit_csv_column_s" => array(
            "friendly_name" 	=> "Column Seperator",
            "description" 	=> "The column seperator to be used for CSV exports",
            "method" 		=> "drop_array",
	    "array"		=> $csv_column_seperator,
	    "default"		=> '1',
	    ),
        "reportit_csv_decimal_s"=> array(
            "friendly_name" 	=> "Decimal Seperator",
            "description" 	=> "The symbol indicating the end of the integer part and the beginning of the fractional part",
            "method" 		=> "drop_array",
	    "array"		=> $csv_decimal_seperator,
	    "default"		=> '0',
	    ),
    
	);
	
	if (isset($settings_graphs["reports"]))
    	    $settings_graphs['reportit'] = array_merge($settings_graphs['reportit'],$temp);
        else
    	    $settings_graphs['reportit']=$temp;
	unset($temp);
}



function reportit_show_tab () {

    global $config, $user_auth_realms, $user_auth_realm_filenames;
    $realm_id2 = 0;

    if (isset($user_auth_realm_filenames{basename('cc_view.php')})) {
        $realm_id2 = $user_auth_realm_filenames{basename('cc_view.php')};
    }
    if ((db_fetch_assoc(
	"select user_auth_realm.realm_id
    	 from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
	 and user_auth_realm.realm_id='$realm_id2'"
	 )) || (empty($realm_id2))) {
        print '<a href="' . $config['url_path'] . 'plugins/reportit/cc_view.php"><img src="' . $config['url_path'] . 'plugins/reportit/images/tab_reportit.gif" alt="Report it!" align="absmiddle" border="0"></a>';
    }
    reportit_setup_table();
}



function reportit_setup_table () {

    global $config, $database_default;
    include_once($config["library_path"] . "/database.php");
	
    $sql	= "show tables from " . $database_default;
    $result 	= db_fetch_assoc($sql) or die (mysql_error());
    $tables 	= array();
    $sql 	= array();

    foreach($result as $index => $arr) {
        foreach($arr as $tbl) {
            $tables[] = $tbl;
        }
    }

    if (!in_array('reportit_reports', $tables)) {
        $sql[] = "CREATE TABLE reportit_reports (
                    id 			INT 	     NOT NULL AUTO_INCREMENT PRIMARY KEY,
                    description 	VARCHAR(255) NOT NULL,
		    template_id		INT	     NOT NULL,
		    preset_timespan	VARCHAR(255) NOT NULL,
		    last_run		DATETIME     NOT NULL,
		    runtime		INT	     NOT NULL,
		    public		VARCHAR(3)   NOT NULL,
		    start_date		DATE	     NOT NULL,
		    end_date		DATE	     NOT NULL,
		    ds_description	VARCHAR(255) NOT NULL,
		    result_description	VARCHAR(255) NOT NULL,
		    `dynamic`		TINYINT(1)   NOT NULL DEFAULT '0',
		    present		TINYINT(1)   NOT NULL DEFAULT '0',		    
		    scheduled		TINYINT(1)   NOT NULL DEFAULT '0',
		    frequency		VARCHAR(225) NOT NULL
                  )TYPE=MyISAM;";
    }
        
    if (!in_array('reportit_functions', $tables)) {
	$sql[] = "CREATE TABLE reportit_functions (
		    id			INT          NOT NULL AUTO_INCREMENT PRIMARY KEY,
    		    description 	VARCHAR(255) NOT NULL,
		    calc_function	VARCHAR(255) NOT NULL,
                    included_rra	VARCHAR(255) NOT NULL
                  )TYPE=MyISAM;";
	//Insert standard functions:
	$sql[] = "INSERT INTO reportit_functions (description, calc_function, included_rra) VALUES ( 'minimum', 'calc_min', 'MIN')";
	$sql[] = "INSERT INTO reportit_functions (description, calc_function, included_rra) VALUES ( 'maximum', 'calc_max', 'MAX')";			  		  
	$sql[] = "INSERT INTO reportit_functions (description, calc_function, included_rra) VALUES ( 'average', 'calc_average', 'AVERAGE')";
	$sql[] = "INSERT INTO reportit_functions (description, calc_function, included_rra) VALUES ( 'threshold', 'calc_threshold', 'AVERAGE')";
    }

    if (!in_array('reportit_templates', $tables)) {
        $sql[] = "CREATE TABLE reportit_templates (
                    id 			INT 	     NOT NULL AUTO_INCREMENT PRIMARY KEY,
                    description 	VARCHAR(255) NOT NULL,
		    function_id		INT	     NOT NULL,
		    type_id		INT	     NOT NULL,  
		    user_id		INT	     NOT NULL
                  )TYPE=MyISAM;";
    }

    if (!in_array('reportit_variables', $tables)) {
        $sql[] = "CREATE TABLE reportit_variables (
                    id 			INT 	     NOT NULL AUTO_INCREMENT PRIMARY KEY,
		    template_id		INT	     NOT NULL,
		    field_name		VARCHAR(255) NOT NULL,  
		    value		VARCHAR(255) NOT NULL
                  )TYPE=MyISAM;";
    }
    
    if (!in_array('reportit_types', $tables)) {
        $sql[] = "CREATE TABLE reportit_types (
                    id 			INT 	     NOT NULL AUTO_INCREMENT PRIMARY KEY,
		    type		VARCHAR(255) NOT NULL,  
		    syntax		VARCHAR(255) NOT NULL,
		    multiplier		INT	     NOT NULL
                  )TYPE=MyISAM;";
	//Insert standard functions:
	$sql[] = "INSERT INTO reportit_types (type, syntax, multiplier) VALUES ( 'CPU', '%CPU', '1')";
	$sql[] = "INSERT INTO reportit_types (type, syntax, multiplier) VALUES ( 'Network Interfaces', '%Traffic%', '8')";			  		  
	$sql[] = "INSERT INTO reportit_types (type, syntax, multiplier) VALUES ( 'Serial Interfaces', '%Traffic%Se%', '8')";
	$sql[] = "INSERT INTO reportit_types (type, syntax, multiplier) VALUES ( 'ATM Interfaces', '%Traffic%AT%', '8')";
	$sql[] = "INSERT INTO reportit_types (type, syntax, multiplier) VALUES ( 'Ethernet Interfaces', '%Traffic%Et%', '8')";		  
	$sql[] = "INSERT INTO reportit_types (type, syntax, multiplier) VALUES ( 'GBit Ethernet Interfaces', '%Traffic%Gi%', '8')";		  
    }    
    
    if (!empty($sql)) {
	for ($a = 0; $a < count($sql); $a++) {
	    $result = mysql_query($sql[$a]);
	}
    }
}

?>